#!/bin/bash
#
#(: rc.z_TXN_exe.sh
#
#(: TXN-Normal.sh 
#(:    derived from TXN_Pull_All_Code.sh  
#(:
#(:
#! #####################################################################
#!
#(: method of Programmer Docs and Linux Comments.
#! method of Programmer Docs and Linux Comments.
#! "#(:" Docs are transferred  by "TXN" into "comments.txt"
#!       used for Prog Dox to build Documentation for project . 
#!       TXN will pull these out to a separate file for project. 
#!         #(: effectively becomes a 'cut' line
#!
#! "#!"  are program dox, "Keepers". 
#!
#! "#~" , "# " , "#:" 
#!    regular Comments are Culled via "TXN"
#!       TXN will kill these common comments, for min prog/script size.
#!
#! "#" are BASH comments, must not have a "space" following. 
#(:
#! #####################################################################
#!

lcSetCtrl="1"
# set -x   # list of lines 
set -e   # line of error asdf
# control :
# if [ lcSetCtrl ] ; then
    # set -e
    # set +e
# fi
# error line ~ 300-320, grep to 'C', rc.z_TXN_exe.sh no such file or directory
# if writing is commented, then error on next "IFS do done" loop

#########################################################################
# NOTE: 
# # this is KSH notation, not always valid in BOURNE shell, nor SH. 
# # only option to skip over error is to set +e .
# set +e
# while IFS=    read -r line; 
# do 
# done
# set -e
#########################################################################

#(: System Developer Initial DOB 
export gcSysDevDob="220923-0600"
export gcSysDevDob="221210-0800"
export gcSysDevDob="221210-1627"
export gcSysDevDob="221212-2200"
export gcSysDevDob="221213-0547"
export gcSysDevDob="221215-0928"
export gcSysDevDob="221215-1815"
export gcSysDevDob="221216-1815"
export gcSysDevDob="221217-1646"
export gcSysDevDob="221221-1514"
export gcSysDevDob="221225-2049"
export gcSysDevDob="221226-1300"
export gcSysDevDob="221227-2317"
export gcSysDevDob="230102-1200"
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# System Developer ID 
# export gcSysDevId="TXN"
export gcSysDevVer="5.1"
# these do not chanbe.
export gcExeId="TXN"   # ID for Executable program  :::   /Edit_subdir , ie, TXN, MGN, CTB, C2M,  ...
export gcExeFn="TXN_exe.sh"   # executable script 
export gcExeAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_TXN/rc.z_TXN_exe.sh" # exe RUN 
# #################################################################################################
# #################################################################################################
# #################################################################################################




export gcSrcDirId="CTB" # Directory "CTB"
export gcSrcId="CTB" # ID for Source Code file "CTB"

#~ export gcSrcDirId="CTB" # Directory "CTB"
#~ export gcSrcId="CTB-SL" # ID for Source Code file "CTB-SL"

#~ export gcSrcDirId="MGR" # Directory "CTB"
#~ export gcSrcId="MGR" # ID for Source Code file "CTB"




# #################################################################################################
# #################################################################################################
# #################################################################################################
export gcSrcFn="rc.z_${gcSrcId}.sh" # Source script
export gcSrcAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSrcDirId}/rc.z_${gcSrcId}.sh"
# #################################################################################################

#(: ====================================================================
#(: function "end" must have        }    or    } #
#(: gui end must have gui      </window>'    with 'grave' mark '`' 
#(: "#! " is a permanent marker. tricks grep .
#(:
#(: ====================================================================
#(:
#(: Pull All Code from foreign location
#(: goal #1 : Copy Only Code 
#(:
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#~ PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/root/my-applications/bin/ 
#~ PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/usr/lib/gtkdialog/:/MY_/usr-share/My_Dev_/Edit_TXN
PATH=$PATH:/etc/rc.d:/usr/lib/gtkdialog/:/MY_/usr-share/My_Dev_/Edit_TXN



#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Txn_SetVerDts() {     # ACTIVE
#(: ====================================================================
#(: fx(Sys_SetVerDts) === default global specs
#(: called by: fx(CTB_StartUp)  
#(:		for required Developer's Data Entry Code.
#(: param: none
#(: purpose: gather parameters , accept declarations by user, assign mode control
#(: calls: none
#(: method: declare/assign/export 
#(: sends: 
#(: rationale: 
#(: note : 
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#:  capture all params (future development)
export gcCTBparam1="$1"	## "B"  , "U"  , "A"  ## options for "local" control .
export gcCTBparam2="$2" ## "RS" , "RB" , "RQ" ## options to match manager "MGN.sh" .
export gcCTBparam3="$3"
. /etc/DISTRO_SPECS
export gcSysDistroName="${DISTRO_NAME}"
. /etc/rc.d/PUPSTATE
#: export gcVerDtsTmpPS=""	# temp var,  used before/after loading PUPSTATE
#: export gcSysDvar=`date` # not used 
export gcTxnZeroRun="$0"

export gcTxnDts="`date +%y%m%d-%H%M-%S`"     
export gcTxnFnOut="${gcSrcId}-Txn-`date +%y%m%d-%H%M-%S`"     

# === begin: Config Reader ==============================================
gcTxnConfigFN="/root/my-applications/bin/Txn_config"	
gcTxnConfigTrgPrefix=""			

	#~ if [ -f ${gcTxnConfigFN} ]  ; then  
		#~ n=0
        #~ #: if config, then read AS-IS 
        #~ #: CTB : this will 'cat a single line of data into a var .
		#~ gcTxnConfigTrgPrefix=`cat ${gcCtbConfigFN}`
		#~ #: now we have the alternate target subdir for casting the new saveDATA.tar.gz
	#~ else	
		#~ lnDummy=1
        #~ touch ${gcTxnConfigFN} 	
        #~ #: else not config file found, simply cast into local saveDATA home file.
	#~ fi

export gcTxnConfigTrgPrefix="${gcCtbConfigTrgPrefix}"	
# === end: Config Reader ==============================================
#	
} #( end: fx(Txn_SetVerDts) 




    
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_validate_BACKUP_location() { # $PBKP_BACKUP_PATH

	if [ "${1}" != "" ]; then 
		IFS="/" read -r a direntry level2 level3 level4 <<< "${1}"
		#                /mnt     /home  /psubidir                /mnt/sda2/etc
		if [ "$direntry" = "mnt" ] && [ "$level2" != "" ] ; then
			echo -n "${1}"
		elif [ "$direntry"/"$level2" = "initrd/mnt" ] && [ "$level3" != "" ] ; then
			echo -n "${1}"
		fi
    else
		echo -n "$PBKP_LOCDEFAULT"
	fi
} # end: fx(PBKP_validate_BACKUP_location)

#~ echo "${PBKP_LOCDEFAULT}"    | PBKP_validate_BACKUP_location
#~ echo "'\${PBKP_BACKUP_PATH}'"
#~ echo "'${PBKP_validate_BACKUP_location $gcSrcAll}'"




#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Txn_ReStart() { 
    n=0
    #~ ${gcTxnZeroRun}
} # end: Txn_ReStart



########################################################################
### function Txn_Run ############################################################
########################################################################
########################################################################
### function Txn_Run ############################################################
########################################################################
########################################################################
### function Txn_Run ############################################################
########################################################################
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# working function call 
function Txn_Run() {   

lcpSrcId=$1
lcpSrcFn=$2
lcpSrcAll=$3

# global Src: Txn_Run ${gcSrcId}  ${gcSrcFn} ${gcSrcAll}  
# process FnSrcAll into Fn0, Fn1, Fn2, FnX


#########################################################################
    echo "=============================="
    echo "=== parmSrcId:  ${lcpSrcId}"
    echo "=== parmSrcFn:  ${lcpSrcFn}"
    echo "=== parmSrcAll: "
    echo ":${lcpSrcAll}:"
    echo "=============================="
#########################################################################
    echo " "
    echo "#: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;"
    echo ">>> {lcpSrcAll} into 'Fn0' copy of original without blank lines"
    echo ">>> grep ${lcpSrcAll}"
    echo ">>> grep ${lcpTrgAll}"
    echo ""
#########################################################################
#~ read

# global Src: Txn_Run ${gcSrcId}  ${gcSrcFn} ${gcSrcAll}  

lcFnSrcAll="${lcpSrcAll}"
lcFnTrg0="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/TXN_code-0.sh"

        echo " "
        echo "#: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;"
        echo "#>>> grep 'Src' into '0' with No Blank lines"   #> "${lcFnTrg0}"

   grep -v '^$' ${lcFnSrcAll} > ${lcFnTrg0}

        echo "<<<"
        echo "=== DONE bulding 'Fn0' copy of original Source without blank lines ==="

#~ read
#~ exit

lcFnSrc0="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/TXN_code-0.sh"
lcFnTrg1="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/TXN_code-1.sh"

        echo " "
        echo "#: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;"
        echo "# >>> grep '0' into '1' for No Blank lines>>>"   #> ${lcFnTrg1}  

   grep -v '^$'  ${lcFnSrc0} > ${lcFnTrg1}

        echo "<<<"
        echo "=== DONE bulding '1' copy of original Source without blank lines ==="
                   
#~ read
#~ exit 0

#########################################################################
### extract all #(: comments 

    echo " "
    echo "#: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;"
    echo ">>> grep '1' into 'C' Comments for System Comments"    #> ${lcFnTrgC}  
    echo ">>> so Src1 is code only. "
    echo ""

    ###
    echo " "

    lcFnSrcCode1="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_TXN/TXN_code-1.sh"

    lcFnTrgCodeC="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_TXN/TXN_code-C.sh"
    echo " " > ${lcFnTrgCodeC}  
    chmod +x ${lcFnTrgCodeC}

    grep  '#(:'  ${lcFnSrcCode1} > ${lcFnTrgCodeC}           # "." transfers SrcFile if  "#(:"   

                    # FnAllComment: OK # # OK # # OK # # OK # 

        echo "=== DONE bulding 'C' Comments ==="

#~ read
#~ exit 

#########################################################################
### extract all code lines. 

#########################################################################
echo ""
echo "#========================================================"
echo "=== function: ( '1' into '2' ) =============================="
echo "--- reading 'Fn1' 'Source' "
echo "---  SCAN to Cull program comments"
echo "=== scanning/culling '1' into '2' ======== READ ======="
echo ''
# it must work on any valid Unicode code point
# lcLineVar=$' \t abc \t ' echo "=${lcLineVar##+([[:space:]])}="

lcFnSrc1="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcExeId}_code-1.sh" # Fn"1"
lcFnTrg2="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcExeId}_code-2.sh" # Fn"2" 
echo " " > ${lcFnTrg2}  
chmod +x ${lcFnTrg2}

    echo "=============================="
    echo "=== parmSrcId:  ${lcpSrcId}"
    echo "=== parmSrcFn:  ${lcpSrcFn}"
    echo "=== parmSrcAll: "
    echo ":${lcpSrcAll}:"
    echo "=============================="
    echo ""
    
echo "====================================================================="
echo "=== while IFS ====== SCANNING  ${line} to CULL program comments"
#~ echo "--- reading Fn 'Source' --- Culling program comments-----------"
lciLineCnt=0
echo "====================================================================="
echo "::: begin: IFS at ${lciLineCnt} ::: "

if [ lcSetCtrl ] ; then ### IFS always returns a non'0' value
    set +e
fi

# this is KSH notation, not always valid in BOURNE shell. 
# will always gen err flg !  -e will detect this err flg.
# only option is to skip over error, by set +e .
while IFS=    read -r line; 
do 
    (("lciLineCnt++")) 
    if [ $(expr $lciLineCnt % 100) = "0" ]; then
        echo -n "_${lciLineCnt}"
    fi

    i=0

    lcLineVar="$line"   # transfer to 'var' 
    lciVar=""

    for i in $(seq 1 ${#lcLineVar}); do   # 2 bytes 
            n=0        
            # "lcLineVar" is the WHOLE "line" 
            lcLineVarX="$(echo -e "${lcLineVar}" | sed -e 's/^[[:space:]]*//')"
            lciVar2="${lcLineVarX:i-1:2}"  # 2 bytes from ltrim var
            lciVar3="${lcLineVarX:i-1:3}"  # 3 bytes from ltrim var
  
            #! CULL  "BashComment" : prob: only works at left margin, not tabbed, not spaced 
            #! so, to Cull program comments, we setup to extract remainder via  grep -v into #2
            #! TRAP all remainining "comments" . 
            if  [ "${lciVar2}" = "#~" ] || [ "${lciVar2}" = "# " ]  || [ "${lciVar2}" = "#:" ]    ;  then
                n=0
                break  > /dev/null   # end of line parse. 
            else
                #! still must cull "#(:"     #### old 'fox' char3 style comment
                if  [ "${lciVar3}" = "#(:" ] ; then
                    n=0
                    break  > /dev/null   # end of line parse. 
                fi
                #! KEEP "notes" 
                n=0
                #: keep "#:" code notes
                #:
                #! keep "#!" system notes
                #! 
                #!## Build WHOLE "line" into Fn2  
                echo "${lcLineVar}" >> ${lcFnTrg2}    # OK output to file. 
                break   # end of line parse loop, break to "while IFS=    read -r line;"
                #!
            fi # fall-thru to 'continue' iterating "line" 

    done   # includes spaces.evaluates to the value of $var, unless $var isn't set in which case it evaluates to the text "default"

done < "${lcFnSrc1}" # feeds whole file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

echo ""
echo "::: end: IFS at ${lciLineCnt} ::: "
echo "====================================================================="
echo "=== while IFS ====== SCANNING Fn1 to CULL program comments"
echo "====================================================================="
sleep 3
if [ lcSetCtrl ] ; then 
    set -e
fi

#~ read
#~ exit

#: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sync
echo "#================================================================="
echo "=== BUILD: 'RUN' current FileOutPut ======================= READ ==="

lcFnSrc2="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcExeId}_code-2.sh" # Fn"2"  
lcFnTrg3="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcExeId}_code-RUN-${gcSrcId}.sh" # Fn"3" RUN
echo " " > ${lcFnTrg3}  
chmod +x ${lcFnTrg3}

cp -v  "$lcFnSrc2"   "$lcFnTrg3"   # build ???_Txn_dts.sh
chmod +x ${lcFnTrg3}


echo "#================================================================="
echo "=== BUILD: 'X' with DTS ======================= READ ==="

lcFnSrc3="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcExeId}_code-RUN.sh" # Fn"3"  RUN
lcFnTrgX="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcSrcId}_Txn_${gcTxnDts}.sh" # X = DTS
echo " " > ${lcFnTrgX}  
chmod +x ${lcFnTrgX}

#~ echo "lcFnSrc3===${lcFnTrgX}"   # Build Special file.sh
cp -v  "$lcFnSrc3"   "$lcFnTrgX"   # build ???_Txn_dts.sh  # DTS builds large group of FileOutDTS.
chmod +x ${lcFnTrgX}

echo "#================================================================="
echo "=== DONE sbr(0,C,1,2,RUN, X.sh) ======================= READ ==="

#~ sync

#~ read
#~ exit

} # end: function Txn_Run
########################################################################










########################################################################
### main() #############################################################
### main() #############################################################
### main() #############################################################
########################################################################


#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: Standard 
#(: ${gcSD_IdExeID}_0.sh MUST contain the SOURCE 
#(: TXN_exe.sh  runs on gcSrc* file from a "foreign" subdir.
#(: TXN_exe.sh  writes to ${gcSD_IdExeID} location, "local".

#(: ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ move to top header below gcSysDOB
#~ gcSrcId="CTB" # ID for Source Code 
#~ gcSrcFn="rc.z_${gcSrcId}.sh" # Source script
#~ gcSrcAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSrcId}/rc.z_${gcSrcId}.sh"
#(: ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

gcFnTrg="${gcSrcId}_Txn_code-2.sh"
gcFnTrgX2="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcSrcId}_Txn_code-2.sh"
gcTxnDts="`date +%y%m%d-%H%M-%S`"     
gcFnTrgX="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/${gcSrcId}_Txn_${gcTxnDts}.sh"

Txn_SetVerDts

export PBKP_LOCDEFAULT="/mnt/home${PSUBDIR}"
export PBKP_BACKUP_PATH=$(PBKP_validate_BACKUP_location)




### #1 ### copy original to TXN "0" file
gcFnTrg="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcExeId}/TXN_code-0.sh" # plus extensions

echo ""
echo ""
echo ""
echo "$gcGaeBusyBox"

echo "#################################################################"
echo "=== Main Menu === TXN === Text =================================="
echo "SrcId: ${gcSrcId}:   SrcFn = :${gcSrcFn}:"
echo "SrcAll: ${gcSrcAll}:"
echo ""
echo "Build into:    TargetFn = :Txn_code-RUN-${gcSrcId}.sh:"
#~ echo ":${gcFnTrgX}:"
echo ""
echo ""

echo "================================================ read ==========="
echo "=== hit RETURN to run program " 
echo "=== else close Xterm  or Ctrl-C' "
echo "=== read =========== "
echo "================================================ read ==========="

#~ read
#~ exit


Txn_Run ${gcSrcId}  ${gcSrcFn} ${gcSrcAll}  # process FnSrcAll into Fn0, Fn1, Fn2, FnX


echo ""
echo ""
echo ""
echo "#################################################################"
echo "=== DONE: === TXN === Text =================================="
echo ""
echo "Build from: ${gcSrcId}  :  IFS at ${lciLineCnt} ::: "
echo "${gcSrcFn}: "
echo ""
echo "Build into:   ${gcSrcId}"
echo ":${gcFnTrgX}:"
echo ""
echo "#################################################################"
echo ""


#~ read
exit
### DONE ###




########################################################################
### FINISHED #####################################################################
########################################################################
########################################################################
### FINISHED #####################################################################
########################################################################
########################################################################
### FINISHED #####################################################################
########################################################################



########################################################################
### END of TXN active source-code ######################################
########################################################################
########################################################################
########################################################################
### END ### END ### END ################################################
### END ### END ### END ################################################
### END ### END ### END ################################################
########################################################################
