#(: LIB-extra.sh    EXTRA

# Routines to use as Standard System 

 
#:### MGN PATH  "rc.sysinit" calls functions_x to check/link "/etc/rc.d"
#:### PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/root/my-applications/bin/ 
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/usr/lib/gtkdialog/:/root/my-applications/bin/ 

 

######################################################
# rc.sysinit XXX
#######################################################
export gcSysDevDob="220616-1725"
#######################################################
### only for sysinit / shutdown on specific OS
export gcSysDevOS="XXX"
export gcSysDevId="YY"
#######################################################
### only for sysinit / shutdown on specific OS is UpupJammy-32
# export gcSysDevOS="UpupJJ Jammy Jellyfish"
# export gcSysDevId="JJ"
# export gcSysDevEol="April 2027"  
#######################################################
### only for sysinit / shutdown on specific OS is UpupBB+30
# export gcSysDevOS="UpupBB-32+30"
# export gcSysDevId="BB"
# export gcSysDevEol="April 2025"  
#######################################################
# export gcSysDevId="FF"
# export gcSysDevEol=""  
#"Ubuntu Focal Fossa" 
#"PuppySlacko-7 v.14.2"
#######################################################
# export gcSysDevId="S7"
# export gcSysDevEol=""  
# "Slacko-7" 
# "slacko-7.0_DpupS7_14.2"
#######################################################





#============================================================================
#============================================================================
#============================================================================
### === Signature === rc.sysinit & rc.shutdown === top-of-file ==============
##############################################################
##############################################################
. /etc/rc.d/PUPSTATE
. /etc/DISTRO_SPECS
##############################################################
# rc.sysinit "Header Splash" 
# PUPSTATE already loaded
# DISTRO_SPEC already loaded
# values expressed here: 
##############################################################
export gcSysDistroName="${DISTRO_NAME}"
export gcSysDistroVersion="${DISTRO_VERSION}"
export gcSysDistroPuppySFS="${DISTRO_PUPPYSFS}"
export gcPupSfsFile="`echo "$PUPSFS" | cut -f 3 -d ','`" 	# PUPSFSFILE short name
export gcSysDistro_Db_Subname="$DISTRO_DB_SUBNAME"
export gcSysDistro_PuppyDate="${DISTRO_PUPPYDATE}"
export gcSysBuild_from_Woof="{$BUILD_FROM_WOOF}"
export gcSysKernPup="`uname -r`"
export gcSysKernName="Kern:`uname -r`"
export gcAskToStr="${gcSysDevId} * ${gcSysDistroName} *"
##########################################################################################################
	echo " . " >/dev/console
	echo "  . " >/dev/console
	echo "   . " >/dev/console
	lcMsgStr=":.......${0}......."
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":dob:${gcSysDevDob}...dts:${Distro_PuppyDate}...eol:${gcSysSysDevEol}:"
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":ID: ${gcSysDevId}   :OS: ${gcSysDevOS}:"
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":Build: ${gcSysBuild_from_Woof} :"
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":SFS: ${gcSysDistroPuppySFS} :"
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr="======================================================="
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":Distro_Name: ${gcSysDistroName}"
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":Distro_Db_Subname: ${gcSysDistro_Db_Subname}"
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=":AskToStr: ${gcAskToStr}:"
		/bin/echo -e "\\033[10G\\033[1;38m*** \\033[1;33m $lcMsgStr \\033[1;38m***\\033[0;39m" > /dev/console  

	lcMsgStr=":DistroKern:${gcSysKernPup}:"
		/bin/echo -e "\\033[5G\\033[1;38m*** \\033[1;33m $lcMsgStr \\033[1;38m***\\033[0;39m" > /dev/console

	lcMsgStr="======================================================="
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr=${PUPSAVE}
	/bin/echo -e "\\033[5G\\033[1;35m*** \\033[1;32m ${lcMsgStr} \\033[1;35m***\\033[0;39m" > /dev/console
	/bin/echo -e "\\033[5G\\033[1;36m*** \\033[1;32m ${lcMsgStr} \\033[1;36m***\\033[0;39m" > /dev/console
	/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

	lcMsgStr="======================================================="
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console

sleep 3	### observe results
### end: Signature === rc.sysinit & rc.shutdown ===================================
#==================================================================================
#==================================================================================
#==================================================================================



 


########################################################################
# LIB-extra.sh
### === Signature ==================================================
# end of prg --- bottom of file

lcMsgStr="."
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "\\033[5G\\033[1;35m    \\033[1;35m ${lcMsgStr} \\033[1;35m   \\033[0;39m" > /dev/console
sleep .1

lcMsgStr="======================================================="
/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
sleep .1
lcMsgStr=":... ${0} ... "
/bin/echo -e "\\033[5G\\033[1;35m*** \\033[1;31m ${lcMsgStr} \\033[1;35m***\\033[0;39m" > /dev/console
sleep .1
/bin/echo -e "\\033[5G\\033[1;36m*** \\033[1;32m ${lcMsgStr} \\033[1;36m***\\033[0;39m" > /dev/console
sleep .1
/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console
sleep .1
lcMsgStr="======================================================="
/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
sleep 3
# end of prg --- bottom of file
#~ gcFreeRamNow="${FREERAM}"
	#~ lcMsgStr="...FreeRam: ${gcFreeRamNow} ..."
	#~ /bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
	#~ lcMsgStr="........... END ..........."
	#~ /bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
### end: Signature =================================================
#======================================================================================================


##################################################################################################
# LIB-extra.sh
# rc.sysinit
# . /etc/rc.d/rc.local
# gae, user added info , each boot is fresh update.
echo "#######################################################" 	>  /etc/rc.d/rc.local-user-id
echo "# gcSysDevDob=${gcSysDevDob}" 							>> /etc/rc.d/rc.local-user-id
echo "# gcSysDevId=${gcSysDevId}" 								>> /etc/rc.d/rc.local-user-id
echo "# gcSysDevOS=${gcSysDevOS}"		   						>> /etc/rc.d/rc.local-user-id
echo "# gcSysDistroName=${gcSysDistroName}" 					>> /etc/rc.d/rc.local-user-id
echo "# gcSysDistroVersion=${gcSysDistroVersion}" 				>> /etc/rc.d/rc.local-user-id
echo "# gcSysDistroPuppySFS=${gcSysDistroPuppySFS}" 			>> /etc/rc.d/rc.local-user-id
echo "# gcSysKernPup=${gcSysKernPup}" 							>> /etc/rc.d/rc.local-user-id
echo "# gcSysKernName=${gcSysKernName}" 						>> /etc/rc.d/rc.local-user-id
echo "#######################################################" 	>> /etc/rc.d/rc.local-user-id
##################################################################################################


#=== PUPSTATE === UPDATE ===============================================
# LIB-extra.sh
### PupState UpDate after rc.sysinit "Header" "Signature" 

   (
echo "######################################## injected via rc.sysinit"
echo "export gcSysDevDob='${gcSysDevDob}'"
echo "export gcSysDevId='${gcSysDevId}'"
echo "export gcSysDevOS='${gcSysDevOS}'"
echo "export gcSysDistroName='${gcSysDistroName}'"
echo "export gcSysKernPup='`uname -r`'"
echo "export gcSysKernName='Kern:`uname -r`'"
echo "#######################################################"
   ) >> /etc/rc.d/PUPSTATE
#==============================================================================



########################################################################
# LIB-extra.sh
### === Signature ==================================================
# end of prg --- bottom of file

lcMsgStr="."
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "\\033[5G\\033[1;35m    \\033[1;35m ${lcMsgStr} \\033[1;35m   \\033[0;39m" > /dev/console
sleep .1

lcMsgStr="======================================================="
/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
sleep .1
lcMsgStr=":... ${0} ... "
/bin/echo -e "\\033[5G\\033[1;35m*** \\033[1;31m ${lcMsgStr} \\033[1;35m***\\033[0;39m" > /dev/console
sleep .1
/bin/echo -e "\\033[5G\\033[1;36m*** \\033[1;32m ${lcMsgStr} \\033[1;36m***\\033[0;39m" > /dev/console
sleep .1
/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console
sleep .1
lcMsgStr="======================================================="
/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console

sleep 3
# end of prg --- bottom of file
#======================================================================================================








#======================================================================================================
# LIB-extra.sh 
### paste into all "rc.shutdown" ################################################
asktosave_func () {
 # if $RAMSAVEINTERVAL > 0, session is saved automatically, via countdown to number.
 if [ "$RAMSAVEINTERVAL" ] && [ $RAMSAVEINTERVAL -gt 0 ] ; then
   RETVAL=0
 elif [ "$ASKTOSAVE" = "false" ]; then
   RETVAL=0
 else
   dialog --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
	$(gettext 'Press ENTER to save session...
	wait 6 seconds to NO SAVE')" 6 36 >/dev/console
   RETVAL=$?
 fi
 [ $RETVAL -ne 0 ] && echo "$(gettext "Session NOT Saved ...")" >/dev/console
 [ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ...")" >/dev/console
	   #~ dialog --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
	   #~ $(gettext 'Press ENTER key to save session...
	   #~ wait 6 seconds to No Save...')" 6 36 >/dev/console
	   #~ RETVAL=$?
   dialog  --title "*  ${gcSysDistroName}  *" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
  $(gettext 'hit ENTER to save session...
  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console
   RETVAL=$?
 #~ fi

	echo " " > /dev/console
	[ $RETVAL -ne 0 ] && echo "$(gettext "Session NOT Saved ...")" >/dev/console
	[ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ...")" >/dev/console
	echo " " > /dev/console

	sleep .1
 return $RETVAL
}
###############################################################################
	#~ echo " " > /dev/console
	#~ [ $RETVAL -ne 0 ] && echo "$(gettext "Session NOT Saved ...")" >/dev/console
	#~ [ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ...")" >/dev/console
	#~ echo " " > /dev/console
	 #~ [ $RETVAL -ne 0 ] && echo "$(gettext "Session Not Saved")" >/dev/console
	 #~ [ $RETVAL -ne 0 ] && 	lcMsgStr="NOT Saving ... ${SAVEFILE} to ${SAVEPART}"
	 #~ [ $RETVAL -ne 0 ] && 	lcMsgStr="NOT Saving ... ${SAVEFILE} to ${SAVEPART}"

	 #~ [ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ...")" >/dev/console
	 #~ [ $RETVAL -eq 1 ] && 	/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m $lcMsgStr \\033[1;35m***\\033[0;39m" > /dev/console
	 #~ [ $RETVAL -eq 1 ] && 	/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m $lcMsgStr \\033[1;35m***\\033[0;39m" > /dev/console


### asktosave_func ###########################################
asktosave_func () {
 # if $RAMSAVEINTERVAL > 0, session is saved automatically, via countdown to number.
 if [ "$RAMSAVEINTERVAL" ] && [ $RAMSAVEINTERVAL -gt 0 ] ; then
   RETVAL=0
 elif [ "$ASKTOSAVE" = "false" ]; then
   RETVAL=0
 else
	#
   dialog  --title "*  ${gcSysDevOS}  *" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
  $(gettext 'hit ENTER to save session...
  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console
   RETVAL=$?
 fi
 [ $RETVAL -ne 0 ] && echo "$(gettext "Session NOT Saved ...")" >/dev/console
 [ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ...")" >/dev/console
	sleep .1
 return $RETVAL
}
###############################################################################




### rc.shutdown ###############################################################
 13) #PDEV1 and PUPSFS and PUPSAVE
  #/initrd/pup_rw has tmpfs, pup_ro1 has ${DISTRO_FILE_PREFIX}save.2fs file (PUPSAVE), pup_ro2 has PUPSFS file.
  #the above are in aufs at /.
	sleep .2
  if [ "$RAMDISK_SAVE_SESSION" == "" ]; then
   asktosave_func
   retval=$?
  elif [ "$RAMDISK_SAVE_SESSION" == "y" ]; then
   retval=0
  else
   retval=1
  fi
  if [ $retval -eq 0 ]; then
    echo "$(printf "$(gettext 'Saving session to %s (%s)...')" "${SAVEFILE}" "${SAVEPART}")" >/dev/console
	lcMsgStr="Saving Session ... ${SAVEFILE} to ${SAVEPART}"
	/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m $lcMsgStr \\033[1;35m***\\033[0;39m" > /dev/console
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;36m*** \\033[1;32m $lcMsgStr \\033[1;36m***\\033[0;39m" > /dev/console
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
	sleep .1

    /usr/sbin/snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw

  else

    echo "$(printf "$(gettext 'NOT SAVING  session to %s (%s)...')" "${SAVEFILE}" "${SAVEPART}")" >/dev/console

	lcMsgStr="NOT Saving ... ${SAVEFILE} to ${SAVEPART}"
	/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m $lcMsgStr \\033[1;35m***\\033[0;39m" > /dev/console
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;36m*** \\033[1;32m $lcMsgStr \\033[1;36m***\\033[0;39m" > /dev/console
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
	sleep .1

  fi
	sleep .3
  ;;
###############################################################################





########################################################################
### === Signature === End ===============================================

lcMsgStr="."
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "${lcMsgStr}" > /dev/console
/bin/echo -e "\\033[10G\\033[1;35m    \\033[1;35m ${lcMsgStr} \\033[1;35m   \\033[0;39m" > /dev/console
sleep .1

lcMsgStr="======================================================="
/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
sleep .1
lcMsgStr="... ${0} ... "
/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m ${lcMsgStr} \\033[1;35m***\\033[0;39m" > /dev/console
sleep .1
/bin/echo -e "\\033[10G\\033[1;36m*** \\033[1;32m ${lcMsgStr} \\033[1;36m***\\033[0;39m" > /dev/console
sleep .1
/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m ${lcMsgStr} \\033[1;37m***\\033[0;39m" > /dev/console
sleep .1
lcMsgStr="======================================================="
/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console
sleep 3














#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT="gui-X-S-GRsync+")
#(: called by: GUI button
#(: method: Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method:
#(: sends:
#(: rationale:
#(: note :
#(:
if [ "$EXIT" = "X-S-GRsync+" ] ; then
	#
    lnDummy=0
	#
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "\
.
.              Save-GRsync+
.                                                                        "&
# col 74 line length for siazing splash
    RETVAL=$?
	GTKPIDMAIN=$!
    sleep 3
	#
	Sys_RunSMP "19"
	#~ MGN_SnapMergePuppy
	#
	MGN_ClearFlags	### clear lockfile so that WrmPowwerOff can run.
	rm -f "${MGN_BackUpStatus}"
	kill ${GTKPIDMAIN}
	#
	lcMsgStr=">>> S-GRsync+ >>>" && Sys_Str2DevTrm "$lcMsgStr" "6" "1"
	#~ /usr/share/applications/grsync.desktop
	lcRunFile=". /usr/share/applications/grsync.desktop"
          # ". /usr/share/applications/grsync.desktop"
             # /usr/share/applications/grsync.desktop
	${lcRunFile}	&
	lcMsgStr="<<< S-GRsync+ <<<" && Sys_Str2DevTrm "$lcMsgStr" "6" "1"
	#
	#### Now: Do NOT NOT call the RESTART function
    ### "QUIT" Should be a very 'final' quit action
    ### SHOULD NOT NOT RESTART
	#
    EXIT=""	### force "Fall Thru" if "exit 0" fails.
	#
	### "exit 0' should terminate this program.
    exit 0
	#
fi # end: ft("EXIT" = "X-S-GRsync+")






		<button label="-----Back2Root-----" has-focus="false"> <action>lnDummy:0</action> </button>
		<hseparator width-request="3"></hseparator>

		<button label="-----Back2Root-----" has-focus="false"> <action>lnDummy:0</action> </button>
		<hseparator width-request="3"></hseparator>

		<button  tooltip-text=
"Back2Root, + CTB(NoGUI), + ReStart MGN!
will BackUp Development subdir
into /root/my_applications
which is maintained within the saveDATA folder
then ReStart Manager"
			label=" { 'B2R+CTUtil+RS' }   "
			use-stock="true" has-focus="false" height-request="36" >
			<action>EXIT:'B2RCTU+'</action>
		</button>

		<button  tooltip-text=
"Back2Root, + CTB(NoGUI), + ReStart MGN!"
			label=" { 'B2R+CTUtil+RS' }   "
			use-stock="true" has-focus="false" height-request="36" >
			<action>EXIT:'B2RCTU+'</action>
		</button>

		<button label=" '${lcBackUpStatus}'  "
			use-stock="true" has-focus="false" height-request="36"
tooltip-text="	Tar Backup Call method is this:
(1) Click here for simple single Backup to local subdir.
(2) If you want to SCAN other HD and copy Backup.tar.gz out
	THEN first click the "SCAN" button,
	THEN secondly click this "BACKUP" button !">
            <action>EXIT:'BackUpCall+'</action>
		</button>


#~ #!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#~ function Sys_MGN_pMountX() {    #  Not Called :  one direct call to 'mount'
#~ #
#~ #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ #(: fx(Sys_MGN_pMount)
#~ #(: called by : Main_GUI, small button
#~ #(: purpose :  Seek Target Subdir in GTK box.
#~ #(: receives param : none
#~ #(: returns : focus to Main GUI.
#~ #(: note:
#~ #(:  	gtkdialog/box_help will handle format and embedded color text codes.
#~ #(:  	xmessage will NOT handle format and color embedded text codes.
#~ #
#~ lnDummy=0
#~ #

#~ lcMsgStr=">>> Sys_MGN_pMount >>>" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"

    #~ lnDummy=0
#~ lcPupMntPrm=${1}
	#~ #
#~ #-----------------------------------------------------------------------
#~ /usr/lib/gtkdialog/box_splash -fg orange -bg green -close never -text "\
#~ .
#~ .     Quick Pup-Mount ${lcPupMntPrm}
#~ .     direct call to 'mount'
#~ .
#~ .                                                      "&
#~ #------------------------------------------------------------------------
    #~ RETVAL=$?
	#~ GTKPIDMAIN=$!
    #~ #

#~ sleep 3

#~ echo ">>> Mount ===== ${lcPupMntPrm}."

#~ mkdir -p /mnt/${lcPupMntPrm} drv
#~ echo "======================================" >> /mnt/home/my_mount_drv.log
#~ echo "my_mount_drv.log /dev/${lcPupMntPrm} /mnt/${lcPupMntPrm}  " >> /mnt/home/my_mount_drv.log
#~ # mount /dev/${1} /mnt/${1} && echo "Success=====${1} ."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "First try: mount /dev/${1} /mnt/${1} " >> /mnt/home/my_mount_drv.log
#~ mount         /dev/${lcPupMntPrm} /mnt/${lcPupMntPrm} && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "EXT3 try: mount /dev/${1} /mnt/${1}"  >> /mnt/home/my_mount_drv.log
#~ mount -t ext3 /dev/${lcPupMntPrm} /mnt/${lcPupMntPrm} && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "VFAT try: mount /dev/${1} /mnt/${1}"  >> /mnt/home/my_mount_drv.log
#~ mount -t vfat /dev/${lcPupMntPrm} /mnt/${lcPupMntPrm} && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "<<< Done ===== ${lcPupMntPrm} :"

	#~ sleep 1
	#~ kill ${GTKPIDMAIN}


#~ lcMsgStr="<<< Sys_MGN_pMount <<<" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"


#~ } # end: fx(Sys_MGN_pMount)
#~ ###############################################################################








### develop custom "dialog"

# dialog --help
#~ cdialog (ComeOn Dialog!) version 1.3-20171209
#~ Copyright 2000-2016,2017 Thomas E. Dickey
#~ This is free software; see the source for copying conditions.  There is NO
#~ warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

#~ * Display dialog boxes from shell scripts *

#~ Usage: dialog <options> { --and-widget <options> }
#~ where options are "common" options, followed by "box" options

#~ Special options:
  #~ [--create-rc "file"]
#~ Common options:
  #~ [--ascii-lines] [--aspect <ratio>] [--backtitle <backtitle>] [--beep]
  #~ [--beep-after] [--begin <y> <x>] [--cancel-label <str>] [--clear]
  #~ [--colors] [--column-separator <str>] [--cr-wrap] [--date-format <str>]
  #~ [--default-button <str>] [--default-item <str>] [--defaultno]
  #~ [--exit-label <str>] [--extra-button] [--extra-label <str>]
  #~ [--help-button] [--help-label <str>] [--help-status] [--help-tags]
  #~ [--hfile <str>] [--hline <str>] [--ignore] [--input-fd <fd>]
  #~ [--insecure] [--item-help] [--keep-tite] [--keep-window] [--last-key]
  #~ [--max-input <n>] [--no-cancel] [--no-collapse] [--no-cr-wrap]
  #~ [--no-items] [--no-kill] [--no-label <str>] [--no-lines] [--no-mouse]
  #~ [--no-nl-expand] [--no-ok] [--no-shadow] [--no-tags] [--nook]
  #~ [--ok-label <str>] [--output-fd <fd>] [--output-separator <str>]
  #~ [--print-maxsize] [--print-size] [--print-version] [--quoted]
  #~ [--reorder] [--scrollbar] [--separate-output] [--separate-widget <str>]
  #~ [--shadow] [--single-quoted] [--size-err] [--sleep <secs>] [--stderr]
  #~ [--stdout] [--tab-correct] [--tab-len <n>] [--time-format <str>]
  #~ [--timeout <secs>] [--title <title>] [--trace <file>] [--trim]
  #~ [--version] [--visit-items] [--week-start <str>] [--yes-label <str>]
#~ Box options:
  #~ --buildlist    <text> <height> <width> <list-height> <tag1> <item1> <status1>...
  #~ --calendar     <text> <height> <width> <day> <month> <year>
  #~ --checklist    <text> <height> <width> <list height> <tag1> <item1> <status1>...
  #~ --dselect      <directory> <height> <width>
  #~ --editbox      <file> <height> <width>
  #~ --form         <text> <height> <width> <form height> <label1> <l_y1> <l_x1> <item1> <i_y1> <i_x1> <flen1> <ilen1>...
  #~ --fselect      <filepath> <height> <width>
  #~ --gauge        <text> <height> <width> [<percent>]
  #~ --infobox      <text> <height> <width>
  #~ --inputbox     <text> <height> <width> [<init>]
  #~ --inputmenu    <text> <height> <width> <menu height> <tag1> <item1>...
  #~ --menu         <text> <height> <width> <menu height> <tag1> <item1>...
  #~ --mixedform    <text> <height> <width> <form height> <label1> <l_y1> <l_x1> <item1> <i_y1> <i_x1> <flen1> <ilen1> <itype>...
  #~ --mixedgauge   <text> <height> <width> <percent> <tag1> <item1>...
  #~ --msgbox       <text> <height> <width>
  #~ --passwordbox  <text> <height> <width> [<init>]
  #~ --passwordform <text> <height> <width> <form height> <label1> <l_y1> <l_x1> <item1> <i_y1> <i_x1> <flen1> <ilen1>...
  #~ --pause        <text> <height> <width> <seconds>
  #~ --prgbox       <text> <command> <height> <width>
  #~ --programbox   <text> <height> <width>
  #~ --progressbox  <text> <height> <width>
  #~ --radiolist    <text> <height> <width> <list height> <tag1> <item1> <status1>...
  #~ --rangebox     <text> <height> <width> <min-value> <max-value> <default-value>
  #~ --tailbox      <file> <height> <width>
  #~ --tailboxbg    <file> <height> <width>
  #~ --textbox      <file> <height> <width>
  #~ --timebox      <text> <height> <width> <hour> <minute> <second>
  #~ --treeview     <text> <height> <width> <list-height> <tag1> <item1> <status1> <depth1>...
  #~ --yesno        <text> <height> <width>

#~ Auto-size with height and width = 0. Maximize with height and width = -1.
#~ Global-auto-size if also menu_height/list_height = 0.

#############################################################











#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function myhelp() {	# Not Useful
     Xdialog --left --msgbox \
"---HELP---"
}



if [ "$EXIT" = 'Bugger_XDG+' ] ; then	# Not Useful
    #
    lnDummy=0
	lcMsgStr=">>> Sys_Xdialog-Help-Function >>>" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
	Sys_Xdialog-Help-Function
	lcMsgStr="<<< Sys_Xdialog-Help-Function <<<" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
    MGN_ReStart
fi # end: ft(EXIT:Bugger_XDG+)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_Dialog-Help-Function() {
	lnDummy=0
     dialog --help \
} # end: fx(Sys_Xdialog-Help-Function)
export -f Sys_Dialog-Help-Function



#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_Xdialog-Help-Function() {
 	lnDummy=0
     Xdialog --left --msgbox \
"FILE= $FILE\n"
} # end: fx(Sys_Xdialog-Help-Function)
export -f Sys_Xdialog-Help-Function


Original, with some mods to allow Do/While control
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function MGN_SnapMergePuppy() {		# active
#
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(MGN_SnapMergePuppy)
#(: called by:
#(: param:
#(: purpose:
#(: calls: 	nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
#(: method: code calling handled internal,
#(:		could call to external S2F-1 multiple times.
#(: sends:
#(: rationale:
#(: note :
#(:

	### purpose: one-shot "SMP"
	### nice -19 puts SMP at top of priority stack

	lnDummy=0

### main splash

llRun01=1
llRun02=0
llRun03=0
llRun04=0

lcRunTime01="19"
lcRunTime02="18"
lcRunTime03="17"
lcRunTime04="16"


#=======================================================================
#(: test for exist the latest SMP "GitHub" version.
#(: generate "$gcRunFile" the name of a specific "snapmergepuppy"

	if [ -f /usr/sbin/snapmergepuppy-github.sh ] ; then
		lnDummy=0
		export gcFlgGitHub="<GitHub>"	# display in splash
		export gcRunFile="/usr/sbin/snapmergepuppy-github.sh  /initrd/pup_ro1 /initrd/pup_rw"
	else
		lnDummy=0
		export gcFlgGitHub="<STD>"
		export gcRunFile="snapmergepuppy  /initrd/pup_ro1 /initrd/pup_rw"
	fi



#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

lcRunNum="${lcRunTime01}"
### left margin position dependent
/usr/lib/gtkdialog/box_splash -fg yellow -bg brown -close never -text "\
.
.           ...Save-2-Flash...${gcFlgGitHub}...
.             nice -n ${lcRunNum} snapmergepuppy
.                                                                        "&
# -------------------------------------- col 74 line length for sizing splash
    RETVAL=$?
	GTKPIDSMP=$!

 	echo ">>> SnapMergePuppy >>>"
	nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
	echo "<<< SnapMergePuppy <<<"
    sleep 1

	kill ${GTKPIDSMP}


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcRunNum="${lcRunTime02}"
### left margin position dependent
/usr/lib/gtkdialog/box_splash -fg yellow -bg brown -close never -text "\
.
.           ...Save-2-Flash...Standard...
.             nice -n ${lcRunNum} snapmergepuppy
.                                                                        "&
# -------------------------------------- col 74 line length for sizing splash
    RETVAL=$?
	GTKPIDSMP=$!

 	echo ">>> SnapMergePuppy >>>"
	nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
	echo "<<< SnapMergePuppy <<<"
    sleep 1

	kill ${GTKPIDSMP}


# begin === While Do Done =====================================================
#  1            2            3              4
# "$gcRunCnt" "$gcNiceNum" "$gcFlgGitHub" "$gcRunFile"

# receives gcRunCnt, gcNiceNum, gcFlgGitHub, gcRunFile

	touch "/0-MGN-S2F-0-DTS.mark"	# trace SMP has been run DTS

	WAITCNT=3
   while [ ${WAITCNT} -gt 0 ];do

	gcRunCnt="${WAITCNT}" && gcNiceNum="19" && S2F_RunSMP "$gcRunCnt" "$gcNiceNum" "$gcFlgGitHub" "$gcRunFile"

    WAITCNT=`expr $WAITCNT - 1`
    sleep .5
    echo -n " $WAITCNT" >/dev/console
   done

	touch "/0-MGN-S2F-1-DTS.mark"

# end === While Do Done =====================================================


##############################################################################

		<button label="{ '-----Back2Root-----' }"
			has-focus="false" height-request="56" use-stock="true"
	tooltip-text="	Back2Root !
	will BackUp Development subdir
	into /root/my_applications
	which is maintained within the saveDATA folder	">
			<action>lnDummy:0</action>
		</button>

		<button label=" { 'B2R+CTUtil+ReStart' } "
			has-focus="false" use-stock="true" height-request="32"
tooltip-text="'EXIT:B2RCTURS+'
	Back2Root,
+ CTB (NO GUI),
+ ReStart MGN!">
			<action>'EXIT:B2RCTURS+'</action>
		</button>

		<button label=" { 'B2R+CTBasic+ReStart' } "
			use-stock="true" has-focus="false" height-request="32"
tooltip-text="'EXIT:B2RCTBRS+'
	Back2Root,
+ CTB (with GUI),
+ ReStart MGN!">
 			<action>'EXIT:B2RCTBRS+'</action>
		</button>


**************************************************************
			${gcSys_MyDev}

			lcFnRun="${gcSys_MyDev}"

			lcFnRun="${gcSys_MyDev}/Edit_XXX/rc.z_XXX.sh"
			echo ">>> running ${lcFnRun} ====================="
			[ -f "${lcFnRun}" ]  &&  ${lcFnRun}
			echo "<<< running ${lcFnRun} ====================="
**************************************************************





            <checkbox
tooltip-text="CBX : E2R + Quit*  local !
will run C2C plus E2R + MNT + CTA + Quit"
				active="'$CBXCEMCQ'">
                <label> 'CBX-CEMCQ'  </label>
                <variable>CBXCEMCQ</variable>
            </checkbox>


            <button>
               <label> '+CEMCQ' </label>
               <input file stock="gtk-apply"> tooltip-text="EXIT:CBXCEMCQ" </input>
               <action>EXIT:'CBXCEMCQ'</action>
            </button>



			<text editable="false" use-markup="true" xalign=".001">
				<label>
				"<span color='"'$lcGuiColorred'"'> <b>'-Apply-Checks-'</b> </span>  "
				</label>
			</text>

##################################################################################

          <button tooltip-text="'EXIT:guiE2D'  < Backup /MY_/usr-share/My_DEV  to all drives " >
               <input file stock="gtk-apply"></input>
               <label> 'E2D' </label>
               <action>'EXIT:guiE2D'</action>
           </button>

##################################################################################

		<button label="'S2F-n1'" tooltip-text="'EXIT:guiS2F-1+'  < Save-2-Flash -n 1 >" has-focus="false">
			<action>'EXIT:guiS2F-1'</action> </button>

		<button label="'S2F-n3'" tooltip-text="'EXIT:guiS2F-3+'  < Save-2-Flash -n 3 >" has-focus="false">
			<action>'EXIT:guiS2F-3'</action> </button>

		<button label="'S2F-n19'" tooltip-text="'EXIT:guiS2F-19+'  < Save-2-Flash -n 19 >" has-focus="false">
			<action>'EXIT:guiS2F-19'</action> </button>

##################################################################################

#~ lcFileSrcTxt="/tmp/box_source"
# cat ${gcCtbZeroRun} > /dev/console
#~ . /usr/share/applications/defaulttexteditor.desktop ${gcCtbZeroRun}

#~ read
#~ exit


###############################################################################
Ubuntu Distribution Name/Sequence
Version:             codename:          release:

    2.1 Ubuntu 4.10 (Warty Warthog)
    2.2 Ubuntu 5.04 (Hoary Hedgehog)
    2.3 Ubuntu 5.10 (Breezy Badger)
    2.4 Ubuntu 6.06 LTS (Dapper Drake)
    2.5 Ubuntu 6.10 (Edgy Eft)
    2.6 Ubuntu 7.04 (Feisty Fawn)
    2.7 Ubuntu 7.10 (Gutsy Gibbon)
    2.8 Ubuntu 8.04 LTS (Hardy Heron)
    2.9 Ubuntu 8.10 (Intrepid Ibex)
    2.10 Ubuntu 9.04 (Jaunty Jackalope)
    2.11 Ubuntu 9.10 (Karmic Koala)
*   2.12 Ubuntu 10.04 LTS (Lucid Lynx) 2010-04-29 (*)
    2.13 Ubuntu 10.10 (Maverick Meerkat)
    2.14 Ubuntu 11.04 (Natty Narwhal)
    2.15 Ubuntu 11.10 (Oneiric Ocelot)
    2.16 Ubuntu 12.04 LTS (Precise Pangolin) 2012-04-26 (*)
    2.17 Ubuntu 12.10 (Quantal Quetzal)
    2.18 Ubuntu 13.04 (Raring Ringtail)
    2.19 Ubuntu 13.10 (Saucy Salamander)
*   2.20 Ubuntu 14.04 LTS (Trusty Tahr) 2014-04-17 (*) older version maintained=2024-04-25
    2.21 Ubuntu 14.10 (Utopic Unicorn)
    2.22 Ubuntu 15.04 (Vivid Vervet)
    2.23 Ubuntu 15.10 (Wily Werewolf)
*   2.24 Ubuntu 16.04 LTS (Xenial Xerus) 2016-04-21 (*) older ver maintained=2026-04-23
    2.25 Ubuntu 16.10 (Yakkety Yak)
    2.26 Ubuntu 17.04 (Zesty Zapus)
    2.27 Ubuntu 17.10 (Artful Aardvark)
*   2.28 Ubuntu 18.04 LTS (Bionic Beaver) 2018-04-26 (*) older ver maintained=2028-04-26
    2.29 Ubuntu 18.10 (Cosmic Cuttlefish)
    2.30 Ubuntu 19.04 (Disco Dingo)
    2.31 Ubuntu 19.10 (Eoan Ermine)
*   2.32 Ubuntu 20.04 LTS (Focal Fossa) 2020-04-23 (*) LTS=2030-04-23
    2.33 Ubuntu 20.10 (Groovy Gorilla)
    2.34 Ubuntu 21.04 (Hirsute Hippo)
    2.35 Ubuntu 21.10 (Impish Indri)
    2.36 Ubuntu 22.04 LTS (Jammy Jellyfish) future 2032
###############################################################################


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT=Bugger_UPL)
#(: called by: Main GUI Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method:
#(: sends:
#(: rationale:
#(: note :
#(:
if [ "$EXIT" = "Bugger_UPL" ] ; then
    lcMsgStr="Bugger_UPL+ ... Example ..........."
	SysUpPopLegal
    MGN_ReStart
fi # end: ft(EXIT:Bugger_UPL)
###----------------------------

##################################################################################



#####################################################################################

### working test Bugger_PM for pMOUNT
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft('EXIT=Bugger_PM') (EXIT=Bugger_PM)	# Not Called
#(: called by: Main GUI Fall-Thru
#(: param:
#(: purpose: rc.z_MNT.sh
#(: calls: /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh
#(: method:
#(: sends:
#(: rationale:
#(: note : Appears that placing PupMount code in MGN is stacking process.
#(:		and it does not run as planned.
#(:		Calling PupMount as an external prg will run OK.
#(:
#~ if [ "$EXIT" = "Bugger_PM" ] ; then	# Not Called
    #~ #
    #~ lnDummy=0
 	#~ #(: this is the external call to PupMount named rc.z_MNT.sh
    #~ #(: Internal call has problems.  External call runs OK.


	#~ /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh

	#~ #
	#~ MGN_ClearFlags	# clear lockfile so that Warm Reboot can run.
	#~ #
    #~ MGN_ReStart
    #~ #
#~ fi  # end: ft(EXIT:'Bugger_PM')
###------------------------------

###################################################################

# MGN trash 220522-2112



       #######################################################################
        ### begin: Mark-DTS
        #
        ### Purpose: Create a "Mark-DTS" file
        ###		to show the date of last time this program was run.
        ### File location is the base  "/" file area.  This is below "/root" at the "system"  level.
        ### This Mark-DTS file is contained in the "saveDATA"
        ### The Mark-DTS will show the last DTS time that this program was run.
        ###
        ### When Tar ( CTB ) is run,
        ### then this running saveDATA is run thru "tar" into the "saveDATA.tar.gz" .
        ### When the "saveDATA.tar.gz" is "extracted"
        ### 	it will contain the DTS of the original "Tar OutFile" creation.
        ### Thus, by opening the "/" directory,
        ###     the user has a method to determine exactly which saveDATA IS mounted.
		### 	Mark-DTS  has gcSysDts appended to its filename.
        #
        ### lcFileDtsOut="/0-MGR_DTS*"
		### rm -f /$lcFileDtsOut
		#
 		### touch DTS Marker file
#        lcFileDtsOut="/0-MGR_DTS"
#        touch  "${lcFileDtsOut}"       ### this is a Zero-Byte DTS Marker file .
		#
        ### end: Mark-DTS
        #######################################################################


#############################################################################

 	#~ echo ">>> SnapMergePuppy >>>"
	#~ nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
    #~ nice -n 19 snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
	#~ echo "<<< SnapMergePuppy <<<"
	# ###################################### col 74 line length for sizing splash
#~ ### left margin position dependent
#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg brown -close never -text "\
#~ .
#~ .           ...Save-2-Flash...Standard...
#~ .             nice -n 18 snapmergepuppy
#~ .                                                                        "&
#~ ###################################### col 74 line length for sizing splash

    #~ RETVAL=$?
	#~ GTKPIDSMP=$!
    #~ sleep .5

	#~ echo ">>> SnapMergePuppy >>>"
    #~ nice -n 18 snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
	#~ echo "<<< SnapMergePuppy <<<"

    #~ sleep 1.5

	#~ kill ${GTKPIDSMP}


### main splash
### left margin position dependent
#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg brown -close never -text "\
#~ .
#~ .           ...Save-2-Flash...Standard...
#~ .             nice -n 1 snapmergepuppy
#~ .                                                                        "&
#~ ###################################### col 74 line length for sizing splash

    #~ RETVAL=$?
	#~ GTKPIDSMP=$!
    #~ sleep .5

	#~ echo ">>> SnapMergePuppy >>>"
    #~ nice -n 17 snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
	#~ echo "<<< SnapMergePuppy <<<"

    #~ sleep 1.5

	#~ kill ${GTKPIDSMP}



###########################################################################################################

		<button label="'S2F-n0'" tooltip-text="'EXIT:guiS2F-3' < SMP -n 3 = Do/While >" has-focus="false">
			<action>'EXIT:guiS2F-0'</action> </button>


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiS2F-1)
#(: called by: GUI button
#(: method: Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method: calls external script
#(: sends:
#(: rationale:
#(: note :
#(:
if [ "$EXIT" = "guiS2F-1" ]  ; then
    echo "--- S2F-1---github+ --- MGN_S2F-1 calls SMP-github---"
    lnDummy=0
	lcFnRun="${gcSys_MyDev}/Edit_S2F/rc.z_S2F-1.sh"
	#~ lcFnRun="/mnt/home/MY_/usr-share/My_Dev_/Edit_S2F/rc.z_S2F-1.sh"
	echo ">>> running ${lcFnRun} ======================================="
	[ -f "$lcFnRun" ]  &&  ${lcFnRun}
	echo "<<< running ${lcFnRun} ======================================="
	MGN_ClearFlags	### clear lockfile so that ReStart can run.
    MGN_ReStart
fi # end: ft(EXIT:guiS2F-1)



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiS2F-3)
#(: called by: GUI button
#(: method: Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method: calls external script
#(: sends:
#(: rationale:
#(: note :
#(:
if [ "$EXIT" = "guiS2F-3" ]  ; then
    echo "--- S2F-3 --- MGN_Save-2-Flash 3---"
    lnDummy=0
	lcFnRun="${gcSys_MyDev}/Edit_S2F/rc.z_S2F-3.sh"
	#~ [ -f "$lcFnRun" ]  &&  	$lcFnRun
	#~ lcFnRun="/mnt/home/MY_/usr-share/My_Dev_/Edit_S2F/rc.z_S2F-3.sh"
	echo ">>> running ${lcFnRun} ======================================="
	[ -f "$lcFnRun" ]  &&  ${lcFnRun}
	echo "<<< running ${lcFnRun} ======================================="
	MGN_ClearFlags	### clear lockfile so that ReStart can run.
    MGN_ReStart
fi # end: ft(EXIT:guiS2F-3)


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiS2F-19)
#(: called by: Main GUI Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method: calls external script
#(: sends:
#(: rationale:
#(: note :
#(:
if [ "$EXIT" = "guiS2F-19" ] ; then
    echo "--- S2F-19 --- MGN_Save-2-Flash 19---"
    lnDummy=0
	#
	#~ lcFnRun="/mnt/home/MY_/usr-share/My_Dev_/Edit_S2F/rc.z_S2F-19.sh"
	lcFnRun="${gcSys_MyDev}/Edit_S2F/rc.z_S2F-19.sh"
	#~ [ -f "$lcFnRun" ]  &&  	$lcFnRun
	echo ">>> running ${lcFnRun} ======================================="
	[ -f "$lcFnRun" ]  &&  ${lcFnRun}
	echo "<<< running ${lcFnRun} ======================================="
    #
	MGN_ClearFlags	### clear lockfile so that ReStart can run.
    MGN_ReStart
	#
fi # end: ft(EXIT:guiS2F-19)










##################################################################


		<button label="  'Gears'   " tooltip-text="'EXIT:guiGEARS'  < special GEARS animation >"  has-focus="false">
			<action>'EXIT:guiGEARS'</action> </button>


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiGEARS)
#(: called by: Main GUI Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method:
#(: sends:
#(: rationale:
#(: note :
#(:
if [ "$EXIT" = "guiGEARS" ] ; then
    echo "--- glxgears --- Run_Special System Application  ---"
    lnDummy=0
	MGN_ClearFlags	### clear lockfile so that ReStart can run.
    lcFnRun="/usr/bin/glxgears"
    echo ">>> running ${lcFnRun} ---  === DEX ==========================="
	Run_Special ${lcFnRun}
    echo "<<< running ${lcFnRun} ---  === DEX ==========================="
	### this 'exit' Will not return .
	exit 0
fi # end: ft(EXIT:guiGEARS)



##################################################################

		<button label="'MntExt'"
tooltip-text="  'EXIT:guiMntExt'
<PupMount All HardDrives
-BB-FF-S7-T6-X7
code External >"
			has-focus="false">
			<action>'EXIT:guiMntExt'</action> </button>


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiMntExt) 	# active 220322 # Works OK on BB, FF, S7 .
#(: called by: GUI button
#(: method: Fall-Thru
#(: param:
#(: purpose:
#(: calls:
#(: method: calls external script
#(: sends:
#(: rationale:
#(: note :
#(: 	calls "rc.z_MNT.sh"  external.
#(:

if [ "$EXIT" = "guiMntExt" ]  ; then

    lcDummy="guiMntExt EXTERNAL"
	#
#-----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg orange -bg green -close never -text "\
.
.   Mount All Hard-Drives  'rc.z_MNT.sh'  'EXTERNAL'
.
.                                                      "&
#------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMAIMNT01=$!
    #
	sleep 3
	echo ">>> MGN >>> Mount rc.z_MNT.sh ===== "

	#(: one call to rc.z_MNT.sh, which runs a "do/while/done" loop
	#(: and generates a log file.
	#~ /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh

#~ lcFnRun="${gcSys_MyDev}/Edit_Mnt/rc.z_MNT.sh"
#~ [ -f "$lcFnRun" ]  &&  	$lcFnRun

	echo "<<< MGN >>> Mount rc.z_MNT.sh ===== "
	#
	kill ${GTKPIDMAIMNT01}
	#
	MGN_ClearFlags	# clear lockfile so that Warm Reboot can run.
	#
	MGN_ReStart
	#
fi # end: ft(EXIT:guiMntExt)







##############################################################
#(: /dev/save  vs   /home

#(:  build the "_EXT" : "_All" or "_Cur"
lcBucSubDirTrgBaseAll="CTB_Backup_"
#
    #note  if [ "`cat /tmp/pup_event_backend/pup_event_module_devpath_log* | grep -m 1 'usb_storage'`" != "" ];then 
lcPupSaveNameWod="${lcPupSaveName}-CTB"
lcPupSaveNameSrcCat="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
lcPupSaveNameSrcSpl="${lcPupSaveName##*/}"
##############################################################


####################################################################
# Terminal
GEANY from Xenial 7.50
/usr/bin/xterm -e bash -c -e "/bin/sh %c"
####################################################################



### CTB Src Dump ##################################################################
#~ lcFileTrgTxt="/tmp/box_help"   # remains in /tmp until "CTB" is "QUIT" closed.
#~ # Header
#~ echo "/tmp/box_help is Dump Target for /usr/bin/gxmessage "  >    ${lcFileTrgTxt}
#~ echo "${DISTRO_NAME}"  >>    ${lcFileTrgTxt}
#~ echo " "  >>    ${lcFileTrgTxt}
#~ #-----------------------------------------------------------------
#~ cat ${0} >> ${lcFileTrgTxt}     # cat

#cp /box_help-0.txt /tmp/box_help-0.txt

#~ #-----------------------------------------------------------------
#~ # has /tmp/box_help
# lcFileTrgTxt="/tmp/box_help"
 #~ echo "${DISTRO_NAME} '/tmp/box_help' is Source_Dump    "  >>    ${lcFileTrgTxt}
 #~ echo " remains in /tmp until 'CTB''SRC' is 'OK''QUIT' "  >>    ${lcFileTrgTxt}
 #~ echo "/usr/bin/gxmessage" >>    ${lcFileTrgTxt}
 #~ lcFileTrgTxt="/tmp/box_help"
# cp /tmp/box_help-0.txt /tmp/box_help
# cp /tmp/box_help /tmp/box_help-out.txt
#Sbr_Box_Message "${DISTRO_NAME} FAQ  Sbr_Box_Ok_Msg and /tmp/box_help" "*" "/tmp/box_help"
######################################################################################



#(: ... For "SCAN" to work,
#(: ... each target drive must have subdir at the "/home" level
#(:     export gcCTBbackupSubDir="/CTB_Backup_"
#(:     (The user can substitute a custome name for the value in gcCTBbackupSubDir. )
#(:     (Author sees no good reason to change this subdir name. )
#(:     It is up to the 'user' to provide this target subdir :
#(:     for example "/initrd/mnt/dev_save/CTB_Backup_".
#(:     for example "/mnt/sdc1/CTB_Backup_".
#(:     for example "/mnt/sdd1/CTB_Backup_".
#(:     for example "/mnt/sde1/CTB_Backup_".
#(:     for example "/mnt/sdf1/CTB_Backup_".
#(: note:
#(:		Author aimed for the generic SDA1, SDB1, SDC1, et al
#(:		User can substitute any drive name,
#(:        even system networked drives.
#(:		Enter new names in subroutine "CTB_ScanList"
#(:
#(: fx(CTB_ScanOne) will test if exist subdir,
#(:                if  [ -d ${lcFileOutDir} ]
#(:           then begin: ScanOne splash & COPY
#(: fx(CTB_ScanOne) has method: Test for Target SubDir exist
#(:   	if  [ -d ${lcFileOutDir} ]
#(:        then continue.
#(:     else will skip any non-qualifiying hard drive target.
#(:





########################################################################
########################################################################
########################################################################

asktosave_func () {		

# if $RAMSAVEINTERVAL > 0, session is saved automatically   #  JJ
if [ "$RAMSAVEINTERVAL" ] && [ $RAMSAVEINTERVAL -gt 0 ] ; then
	RETVAL=0
elif [ "$ASKTOSAVE" = "false" ]; then
	RETVAL=0
else
	  # dialog left margin dependent. 
	  dialog  --title "*  ${gcSysDistroName}  *" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
	  $(gettext 'hit ENTER to save session... 
	  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console 
	   RETVAL=$?
fi
 
if [ "$ASKTOSAVE" = "false" ]; then
	RETVAL=0
else
	  # dialog left margin dependent. 
	  dialog  --title "*  ${gcSysDistroName}  *" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
	  $(gettext 'hit ENTER to save session... 
	  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console 
	   RETVAL=$?
fi
	 [ $RETVAL -ne 0 ] && echo "$(gettext "Session NOT Saved ...")" >/dev/console
	 [ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ...")" >/dev/console
	sleep .1
return $RETVAL
########################################################################
########################################################################
########################################################################







#(:=======================================================
#(:=======================================================
#(:=======================================================
#(:=======================================================
#(: System Docs and Legal are here 
#(:=======================================================
#(: 
#(:   Standard GNU General Public License Header :
#(: 
#(:   2020 root <glen.e77is@Gmail.com>
#(:   website : www.GeoCities.WS/glene77is
#(: 
#(:   This program is free software; you can redistribute it and/or modify
#(:   it under the terms of the GNU General Public License as published by
#(:   the Free Software Foundation; either version 2 of the License, or
#(:   (at your option) any later version.
#(: 
#(:   This program is distributed in the hope that it will be useful,
#(:   but WITHOUT ANY WARRANTY; without even the implied warranty of
#(:   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#(:   GNU General Public License for more details.
#(: 
#(:   To received a copy of the GNU General Public License
#(:   write to the Free Software Foundation, Inc.,
#(:   51 Franklin Street, Fifth Floor, Boston,
#(:   MA 02110-1301, USA.
#(:  
 
#(:=======================================================
#(: 
#(:  191113-1116
#(:      gae, first bug killed was the lingering splash banner 
#(:			 /usr/sbin/pupsave-backup    1.2.1 
#(:         which persisted forever, 
#(:			and was not killed properly at end of orig program.
#(:          ( persisted forever on desktop, until Refresh "X" or "Reboot")
#(:      gae, that bug, and other unreadable complexities, 
#(:          led to total re-write from scratch.
#(:		 gae, then to our development of "Cold-Tar-Backup".sh 
#(:      gae, Design Philosophy : "Simple, Readable, Modular, Modifiable" 
#(: 
#(:=======================================================
#(:  
#(:  Pecuiliar code !    
#(:      /usr/sbin/pupsave-backup    (v.1.2.1)   
#(:  Pupsave_Zipit original , v1 and later,  had "export LOCDEFAULT="/mnt/home"
#(:  LOCDEFAULT was 'hard-coded', in original v1 .  
#(:  LOCDEFAULT was NOT calculated from available values, 
#(:		as per Barry Kauler's example. 
#(:  Surprised me !  
#(:  That caused published HotBackup to fault on my system. 
#(:		which is a USB FlashDrive booting system. 
#(:  Use of Barry Kauler method to determine the LOCDEFAULT works OK.   
#(:  
#(:=======================================================
#(: 
#(: peculiar bug from original Back-2-Tar  (v.1.2.1): now under control :
#(: splash "saving session to savefolder..." was left to linger forever. 
#(: 
#(:=======================================================
#(: 
#(: peculiar bug from original Back-2-Tar  (v.1.2.1): now under control :
#(: On Error, was falling back to original /usr/sbin/   !!!!!!!!!!!!!!!
#(: IF : we are warning only to run on 32bit Frugal save-FOLDER, else failure,
#(: THEN : we do not need to check nor warn-n-exit here !
#(: THEREFORE : this litle block was culled.
#(: lcSF is lcPupSave via "cut -f 3 -d "  above
#(:		if [ ! "$SF" ] ; then   
#(:			### gae, then this is a "full install" and B2T will not handle it.
#(:	    	### /usr/lib/gtkdialog/box_ok 
#(:			###	"Pupsave Backup" error "Currently using a full partition..."
#(:	    	B2T_cleanup
#(:	    	exit
#(:		fi
#(: 
#(:

#(: Frame-Work "header" for each subroutine. 
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_Functional-Name) 
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:

#(:----------------------------------------------------
#(: System Notes, and 
#(:   Standard GNU General Public License Header 
#(:----------------------------------------------------

#(:----------------------------------------------------
#(: "CTB" 
#(: "Cold-Tar-Backup" 
#(: based on "tar" and "GZ" compression methods
#(:		which have been around since year 0 . 
#(: features tar.gz.out file with DTS stamp (Year-Month-Day-Seconds). 
#(: features Scanning-BackUp-to-Multiple-Drives.
#(:
#(: the "Cold-Tar-Backup" program for Puppy Linux saveDATA 
#(:		tested in Official Puppy Linux distros (long list is below). 
#(:
#(: Script name format is 'XXX.sh' so GEANY 
#(:		(1) sees a 'script' executable file.
#(:		(2) sees a 'script' with 'executable permission.
#(:
#(: MGR.sh system ( rc.z_MGN.sh, rc.z_E2R.sh, rc.z_CTB.sh, rc.z_S2F.sh, etc. ) 
#(:	CTB Development subdir is '/initrd/mnt/dev_save/MY_/usr-share/My_Dev_' .
#(: ok to rename to "ColdTarBackup.sh" or anything else.
#(: ok to install anywhere, and activated via desktop icon.
#(:
#(: Developed using Geany :
#(: 	with option "Execute" for trace in "BASH Terminal" for Trace/Debug.
#(: 	Using Geany with option "Execute" activates "BASH Terminal" mode . 
#(: 	Using Geany with option "Execute" will allow good debugging in "BASH Terminal"
#(:		Using Geany with option "Execute" in terminal allows monitoring BASH quirks. 
#(:
#(:	Messages to screen : 
#(: 	All of our "echo" lines will show 'B/W' trace in the "BASH Terminal" screen.
#(: 	All of our "Sys_Str2DevTrm" lines will show 'Color' trace in "BASH Terminal" screen.
#(:
#(: Author's "/Development"  vs.  "/Production" subdirs: 
#(: 	"/Development" is "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/..."
#(:		"/Production" is "/root/my-applications" backed-up with 'save2flash' in saveDATA . 
#(: 	We maintain separation between "Dev/Edit" and "Production-Final" . 
#(:		OK to rename to "ColdTarBackup.sh" or anything else.
#(:		OK to install anywhere, and 'run' via desktop icon.
#(: 
#(: "Development/Edit" files in "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/..." .
#(: (1) run "MGR.sh" to activate the utilities located in "Development" subdir .
#(: (2) run "E2R.sh" to copy "Development" versions  into "/root/my-applications" .
#(: (3) store apps/scripts in "/root/my-applications" 
#(:		so they will archive via "Save2Flash" into "saveDATA" user 'layer'. 
#(: (4) this maintains separation: "/DEVELOPMENT" vs "/PRODUCTION" .
#(:

#(: ----------------------------------------------------
#(: gae, Geany  debug method :
#(: [ "Execute" for BASH-Terminal-Trace-Window ]
#(: write "echo" commands for tracing in the Terminal Window.

#(:----------------------------------------------------
#(:	NOTE: 
#(: BASH stacking control quirk, and non-fatal error. 
#(:
#(:		IF user selects "Scan", "Help", "FAQ", "Source" 
#(:			from top of main page. 
#(:		THEN "stack popping" error exists 
#(:		EVIDENCE may show in terminal screen as a succession of "un-pop" messages. 
#(:
#(:		The concept of strict "scope" (isolation of levels of process 'stack') is not implimented. 
#(:
#(:		see Note On BASH process stack
#(:		published in function "Sys_Box_FAQ"  
#(:		
### <b><span foreground='"'darkred'"'>
#(:  BASH is a very common *nix shell, 
#(:     and its programming language is purely procedural 
#(:     and focused on command execution. 
#(:  Updates to Bash itself have broken older scripts 
#(:     that used to work perfectly fine in UNIX.
### </span></b>

#(: ----------------------------------------------------
#(:  Note : "O.O.P."  [ Object Oriented Programming ] 
#(:  BASH does NOT implement "OOP".
#(:  (gtk)dialog does NOT implement "OOP".
#(:  quoted from "hipersayanx.blogspot.com" › 2012/12 › object-oriented-pr.
#(: 
#(: 
#(:  'O'bject 'O'riented 'P'rogramming (OOP) is a programming paradigm 
#(:  that represents the elements of a problem as entities 
#(:  with a set of properties and actions that it can execute. 
#(:  If you use Bash to write very simple and short scripts, 
#(:  procedural programming is just fine, you don't need more.
#(:  But if your program becomes more and more bigger, 
#(:  a monster BASH system program , 
#(:  then you need a better way to structure your program ...
#(:  Dec 22, 2012
#(:  quoted from "hipersayanx.blogspot.com" › 2012/12 › object-oriented-pr.
#(: 
#(:  These "OOP" Concepts are foreign to Unix Scripting Shell Languages
#(:     Abstraction. 
#(:     Encapsulation. 
#(:     Inheritance. 
#(:     Polymorphism.
#(:
#(:	 The concept of strict "scope" (isolation of levels of process 'stack') is not implimented. 
#(:  Sadly, updates to Bash itself have broken older scripts that used to work perfectly fine in UNIX.
#(:
#(:  A monster BASH script program ( > 10,000 lines ) 
#(:  requires a modern high-level language like Python.
#(: 
#(:  Note:  LockFile 
#(:  'strict' lockfile method NOT implemented.
#(:  	example:      exit 1   
#(:  'strict' WILL exit from PRG script only at the 'base' stack level.
#(: 
#(:  IF 'strict' block is written into a function() ( which is a "sub-routine" )
#(:		[which by definition is a sublevel in the stack], 
#(:  	THEN exit will only "pop" one level at that function() stack level. 
#(:  	and will not quit the PRG as desired. 
#(:  CTB has 'soft' lock method written into main() stack level. 
#(: 

#(: ----------------------------------------------------

#(:  Note: Problem noted at start of reverse engineering process:
#(:  gae, 200603-0958 , serious problem with original source . 
#(:  (1) reference   
#(:  ref note: Pupsave_v1 and later
#(:  	contained hard code [ export LOCDEFAULT="/mnt/home" ].
#(:  "export LOCDEFAULT="/mnt/home" was "Hard-Coded" declare/assignbment.  
#(:  	this LOCDEFAULT would not run on author's Puppy Linux OS
#(: 		Author's OS boots from USB 
#(: 			(1) has  "/initrd/mnt/dev-save" 
#(: 			(2) not "/mnt/home" 
#(: 
#(:  (2) reference   
#(:  Surprised me !    
#(:  Pupsave_Zipit original , v1 and later,  had "export LOCDEFAULT="/mnt/home"
#(:  LOCDEFAULT was 'hard-coded', in original v1 .  
#(:  LOCDEFAULT was NOT calculated from available values, 
#(: 			as per Barry Kauler example (included in this source code). 
#(:  Surprised me !  
#(:  That caused published HotBackup to FAULT on all my Puppy Linux systems. 
#(:  Use of "BK method" to determine the LOCDEFAULT works OK, 
#(:     and has been incorporated in our work (with proper credits to "BK").   
#(:  
#(: 
#(:  Author's Puppy Linux Frugal OS boots via USB flashed-drive
#(: 		(1) has Boot drive as "/initrd/mnt/dev_save/sda1" 
#(:  	(2) has Non-Boot drives as "/mnt/home/sd?1" 
#(: 
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: 
#(:  > Note about Barry Kauler method for specifying the "System Location" :
#(:  > BK = Barry Kauler calculated "system location" as shown below :  
#(:  > calcs are performed after 
#(: 	(1) system has booted : 
#(: 	(2) 'aufs' is running : 
#(:  > gcSaveFileNameMount : 
#(:  ="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
#(:  =cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d '=' 
#(:  > gcSaveFileNameBaseSrc : 
#(:  ="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
#(:  =cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d '='
#(:  > Author's current UpupBB, uPupFF, Slacko64 systems 
#(: 		are located on hard-drive  '"/initrd/mnt/dev_save" /sda1' 
#(:  > which changes after system is 'up and running' to '"/mnt/home"'
#(:  > BK = Barry Kauler calculated "system location" (as shown above) 
#(:  is valid code  
#(: 	(1) after system has booted : 
#(: 	(2) after 'aufs' is running : 
#(:  
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#(: ----------------------------------------------------
#(:  2byte wrote the original 'hot' pupsave-backup v.1.2.1, 2011 .
#(:  Sigberg rewrote into the Fuller version, v.1.3,  2013 .
#(:  glene77is rewrote totally into readable "I.T." form, as "rc.z_CTB.sh", 2020 .
#(:  available on website : www.GeoCities.WS/glene77is
#(: 
#(: ----------------------------------------------------
#(: 
#(:  gae developed 'Cold_Tar_Backup', "CTB".  2019-11 <-> 2021-03.
#(:  This project merge into our system control utilities 
#(: 		(MGN, E2R, C3C, S2F, CTB)
#(:  CTB : our code was based on the idea behind pupsave-backup 1.2.1
#(:  	see Murga forum at 
#(: 	https://forum.puppylinux.com/viewtopic.php?p=3482&hilit=CTB#p3482
#(: 	
#(:  CTB uses standard gtkdialog -v = 0.8.4 release , Laszlo Pere, Thunor.
#(:  CTB has been tested on Official Puppy Linux distros :  
#(: 		Slacko-7	iso-slacko64-14.0.iso
#(: 		Slacko-64	iso-slacko64-7.0_210420.iso
#(: 		Slacko-6.2	iso-slacko-6.9.9.9-k3.16-4G-FF-ABI-2017.iso
#(: 		Xenial-708, Tahr-606, Quirky-7, LxPup-64, UpupBB+29, UpupFF .
#(: 		Puppy distro UpupBB thru +29
#(: 		UpupFF-D08 .
#(:  From the Puppy FAQ: 
#(:  "Wheezy Puppy" is NOT a "Puppy Linux Distro" !!!   
#(:		Wheezy is a Debian Distro with Debian dependencies, with an API designed like Puppy. 
#(:  	Q: What is an official Puppy Linux distribution?
#(:  	A: It must meet two conditions. https://github.com/puppylinux-woof-CE/woof-CE
#(: 		1) It must be built using Woof-CE and its build “recipe” should be in woof-distro. 
#(: 		2) It must be endorsed as “official” by the Puppy Master.
#(:  CTB has been tested on Frugal Install "/saveFOLDER" and "/saveFILE.4fs" systems.
#(:  CTB depends on gtkdialog for Progress Dialog, Help-splash and Main-Gui-splash screens.
#(:  CTB depends on Puppy Linux "PUPSTATE" file, required, for system variables.
#(:  CTB has been designed/tested to work with Puppy Linux Frugal installs.
#(:  CTB has been designed/tested to work with Puppy Linux formats Ext2,3,4.
#(:  CTB has been tested to work with Puppy Linux Frugal, saveFOLDER systems.
#(:  CTB has been tested to work with Puppy Linux Frugal, saveFILE.4fs systems.
#(:  CTB has many 'echo' trace messaages designed for Geany and ROX "BASH Terminal" mode. 
#(:  CTB has many 'echo' trace messaages which only display in the BASH Terminal mode.
#(: 
#(: ----------------------------------------------------
#(: 
#(:  
#(: 
#(:====================================================================
#(: 
#(:   Standard GNU General Public License Header :
#(: 
#(:   2020 root <glen.e77is@Gmail.com>
#(:   website : www.GeoCities.WS/glene77is
#(: 
#(:   This program is free software; you can redistribute it and/or modify
#(:   it under the terms of the GNU General Public License as published by
#(:   the Free Software Foundation; either version 2 of the License, or
#(:   (at your option) any later version.
#(: 
#(:   This program is distributed in the hope that it will be useful,
#(:   but WITHOUT ANY WARRANTY; without even the implied warranty of
#(:   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#(:   GNU General Public License for more details.
#(: 
#(:   To received a copy of the GNU General Public License
#(:   write to the Free Software Foundation, Inc.,
#(:   51 Franklin Street, Fifth Floor, Boston,
#(:   MA 02110-1301, USA.
#(:  

#====================================================================
#(: 
#(:   tar (GNU tar) 1.29
#(:	  "TAR" tape archive has been around since year zero. 
#(:   Copyright (C) 2015 Free Software Foundation, Inc.
#(:   License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
#(:   This is free software: you are free to change and redistribute it.
#(:   There is NO WARRANTY, to the extent permitted by law.
#(:   Written by John Gilmore and Jay Fenlason.
#(: 

#(:====================================================================
#(:====================================================================
#(:====================================================================
#(: 
#(:  191113-1116
#(:      gae, first bug killed was the lingering splash banner 
#(:			 /usr/sbin/pupsave-backup    1.2.1 
#(:          which persisted, and was not killed properly at end of orig program.
#(:          and persisted forever on desktop, until Refresh "X" or "Reboot"
#(:      gae, that bug, and other unreadable complexities, 
#(:          led to total re-write from scratch.
#(:		 gae, then to our development of "Cold-Tar-Backup".sh 
#(:      gae, Design Philosophy : "Simple, Readable, Modular, Modifiable" 
#(: 
#(:====================================================================
#(:  
#(:  Pecuiliar code !    
#(:      /usr/sbin/pupsave-backup    (v.1.2.1)   
#(:  Pupsave_Zipit original , v1 and later,  had "export LOCDEFAULT="/mnt/home"
#(:  LOCDEFAULT was 'hard-coded', in original v1 .  
#(:  LOCDEFAULT was NOT calculated from available values, 
#(:		as per Barry Kauler's example. 
#(:  Surprised me !  
#(:  That caused published HotBackup to fault on my system. 
#(:		which is a USB FlashDrive booting system. 
#(:  Use of Barry Kauler method to determine the LOCDEFAULT works OK.   
#(:  
#(:====================================================================
#(: 
#(: peculiar bug from original Back-2-Tar  (v.1.2.1): now under control :
#(: splash "saving session to savefolder..." was left to linger forever. 
#(: 
#(:====================================================================
#(: 
#(: peculiar bug from original Back-2-Tar  (v.1.2.1): now under control :
#(: On Error, was falling back to original /usr/sbin/   !!!!!!!!!!!!!!!
#(: IF : we are warning only to run on 32bit Frugal save-FOLDER, else failure,
#(: THEN : we do not need to check nor warn-n-exit here !
#(: THEREFORE : this litle block was culled.
#(: lcSF is lcPupSave via "cut -f 3 -d "  above
#(:    if [ ! "$SF" ] ; then   ### gae, then this is a "full install" and B2T will not handle it.
#(:      /usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Currently using a full partition..."
#(:      B2T_cleanup
#(:      exit
#(:    fi
#(:
#(:  /usr/lib/gtkdialog/box_ok "Error" error "File Not Found..."
#(:
#(:====================================================================
#(:====================================================================
#(:===  END of SOURCE CODE ============================================
#(:====================================================================



#########################################################################
# Loop
for i in $@ ; do
	if [ "$i" = "stop" ] ; then #simple thing to do, do it as fast as possible
		[ "`whoami`" != "root" ] && exec sudo -A ${0} ${@}
		. /etc/rc.d/BOOTCONFIG
		echo "PREVEXTRASFSLIST='$EXTRASFSLIST'"
		echo "PREVEXTRASFSLIST='$EXTRASFSLIST'" > /etc/rc.d/BOOTCONFIG.save
		exit
	fi
done

	while [ "$1" != "" ]; do ; process ; done

	case $EXIT in Yes|yes|OK|Ok|ok) return 0 ;; esac

# Linux Bash Hints 
Basic Syntax of while read line
The following syntax is used for bash shell to read a file using while loop:

echo "Begin While loop" > /test.txt
while read -r line; 
do 
   echo "$line" ;
   echo "$line" >> /test.txt
done < input.file
#The option ‘-r’ avoids the backslash escapes from being interpreted. 


$ while read line; 
do 
	echo $line; 
done < OS.txt

cat /etc/passwd | while read LREAD
do
    echo ${LREAD}
done

#!/bin/bash
filename='OS.txt'
n=1
cat /etc/passwd | while read LREAD
do
    echo ${LREAD}
done
while read line; 
do
	# for read each line
	echo "OS distribution line no. $n : $line"
	n=$((n+1))
done < $filename


cat /etc/passwd | while read LREAD
do
    echo ${LREAD}
done
	# sfs_load
	PCPARTS=$(echo "$PCPARTS" | grep '[a-zA-Z]')  # remove blank line
	if [ $(echo "$PCPARTS" | wc -l) -le 1 ]; then
		PARTSPEC=$PCPARTS
		PART=$(echo $PARTSPEC| cut -d'|' -f1)
		PART=$(echo $PART| cut -d '/' -f3)
		return 0
	fi

	if [ -z "$LD" ]; then
		log "free_loopdev: no loop device specified."
		return 1
	fi





#########################################################################


           #~ #: =========================================================================
            #~ lcMsgStr="build BK method into TarOpt"  && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
            #~ #(:  here: simply lay BK var over existing lcPupSaveNameSrc
            #~ #(:  begin === from Barry Kauler =======================================
            #~ #(:  SrcName from "/sys/fs/aufs/si_*/br1" created after bootup/running : 
          #note  if [ "`cat /tmp/pup_event_backend/pup_event_module_devpath_log* | grep -m 1 'usb_storage'`" != "" ];then 
            #~ #(:  lcPupSaveNameSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
            #~ #(:  generates /initrd/mnt/dev_save/pup_UpupBB+24-slx/upupbbsave+24-slx=ro+wh
            #~ #(:  === from Barry Kauler ================================== 
            #~ #(:  requires: "/sys/fs/aufs/si_*/br1" to already have been running. 
            #~ #(:  usable results:
            #~ #(:  lcPupSaveNameSrcAufs="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
            #~ #(:  lcPupSaveNameSrc="${lcPupSaveNameAufs##*/}"

            #~ export lcPupSaveNameAufs="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
            #~ export lcPupSaveNameSrc="${lcPupSaveNameAufs##*/}"  
            #~ #:  currently, this shows in gui display

            #~ #:  build results 
            #~ lcPupSaveNameAufsBK="lcPupSaveNameAufs"	
            #~ #:  long full BK extraction
            #~ lcPupSaveNameSrcBK="lcPupSaveNameSrc"	
            #~ #:  to display FileNameSRC on main Red Splash screen 

            #~ #:  trace results
            #~ lcMsgStr="lcPupSaveNameAufsBK : ${lcPupSaveNameAufs}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
            #~ lcMsgStr="lcPupSaveNameSrcBK : ${lcPupSaveNameSrc}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"

            #~ #:  todo: finish BK install 
            #~ #:  todo: clearup this overlapping display code
            #~ #(:  end === from Barry Kauler =========================================


# export -f Show_SplashIt Show_SplashOK Show_SplashX
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Show_SplashIt() {   # Active Called gae
# called: Show_SplashIt "text" "fg" "bg" "timeout"
/usr/lib/gtkdialog/box_splash -text "${1}" -fg "${2}" -bg "${3}"  -timeout "${4}"  
	GtkPid_SplashIt=$!	# capture PID
	kill ${GtkPid_SplashIt} 
} # end: fx(Show_SplashIt)

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Show_SplashError() {   # Active Called gae
# called: Show_SplashOK "title-OS" "image-error" "text"
/usr/lib/gtkdialog/box_ok "${0}" "error" "$3"
} # end: fx(Show_SplashIt)

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Show_SplashOK() {   # Active Called gae
# called: Show_SplashOK "title" "image" "text"
/usr/lib/gtkdialog/box_ok "$1" "$2" "$3"
} # end: fx(Show_SplashIt)

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Show_SplashX() {   # Active Called 
# called: Show_Splash "text" 
	/usr/lib/gtkdialog/box_splash -close never  -text "$1" &  # box_splash
	pidx=$!
    # kill ${pidx} by caller 
} # end: fx(show_splash) # Not Called


#~ mainGui Vertical Spacers

         #~ <button tooltip-text="'EXIT:guiGEANY' < 'CTB' from Local to all Mounted Drives, has GUI >"  
				#~ has-focus="true" height-request="88">
               #~ <input file stock="gtk-select-color"></input>
               #~ <label> '{__COLD__TAR__BACKUP__}' </label>
               #~ <action>'EXIT:guiCTB'</action>
        #~ </button>

		#~ <button  tooltip-text="'EXIT:guiCTB'  < 'CTB' from Local to all Mounted Drives, has GUI >"
			#~ label="  '{__COLD__TAR__BACKUP__}'    " 
			#~ use-stock="true" has-focus="false" height-request="135" >
			#~ <action>'EXIT:guiCTB'</action>
		#~ </button>


			#~ <text editable="false" use-markup="true" xalign=".5">
				#~ <label> "<span color='"'$lcGuiColorblu'"'> <b>'.'</b> </span> " </label>
			#~ </text>

		#~ <button has-focus="false" width-request="20" tooltip-text="Margin-C1" >
			#~ <label> "" </label> 
            #~ <input file icon="gtk-select-color" ></input> <action>lcDummy:vCMargin-Left</action>
		#~ </button>

        #~ <button label="" has-focus="false" width-request="1"> <action>lxDummy:vC2b</action> </button>
        #~ <button label="" has-focus="false" width-request="1"> <action>lxDummy:vC3b</action> </button>
        #~ <button label="" has-focus="false" width-request="1"> <action>lxDummy:vC4b</action> </button>
        #~ <button label="" has-focus="false" width-request="1"> <action>lxDummy:vC5b</action> </button>

		#~ <button has-focus="false" width-request="20" tooltip-text="Margin-C5" >
			#~ <label> "" </label> 
            #~ <input file icon="gtk-select-color" ></input> <action>lcDummy:vCMargin-Right</action>
		#~ </button>

			<text use-markup="true" xalign=".5">
				<label> "<span color='"'$lcGuiColorblu'"'> <b>'.'</b> </span> " </label>
			</text>





    # #######################################################################
    #: ## === Signature for top-of-file === appears in terminal 

    # begin: Signature splashed onto "start-up" screen. 
    # Display system funxtions has not been setup yet.  
    #      So, Must echo this way into terminal. 	
	#~ lcMsgStr="...${0}......."
		#~ /bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	#~ lcMsgStr="DobPrev:=${gcSysDevDobPrev}..." 
		#~ /bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	#~ lcMsgStr="DevDob:=${gcSysDevDob}...."
		#~ /bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	#~ lcMsgStr="DistroName:=${DISTRO_NAME}..."
		#~ /bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	#~ lcMsgStr="DistroVer:=${DISTRO_VERSION}..."
		#~ /bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	#~ lcMsgStr="DistroDbSubname:=${DISTRO_DB_SUBNAME}..."
		#~ /bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
    #~ # end: Signature 



########################################################################

        	lcMsgStr="...${gcAskToStr}..."   # gae
        	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m$lcMsgStr\\033[1;37m***\\033[0;39m" > /dev/console  
        	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m$lcMsgStr\\033[1;37m***\\033[0;39m" > /dev/console  
        	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m$lcMsgStr\\033[1;37m***\\033[0;39m" > /dev/console  
            sleep 3
            
########################################################################
asktosave_func () {


 # if $RAMSAVEINTERVAL > 0, session is saved automatically   #  JJ
 if [ "$RAMSAVEINTERVAL" ] && [ $RAMSAVEINTERVAL -gt 0 ] ; then
   RETVAL=0
 elif [ "$ASKTOSAVE" = "false" ]; then
   RETVAL=0
 else
	# dialog left margin dependent. 
   dialog  --title "${gcAskToStr}" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
       ------- ${gcAskToStr} -------
  $(gettext 'hit ENTER to save session... 
  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console 
   RETVAL=$?
 fi
	 [ $RETVAL -eq 1 ] && echo "$(gettext "Session SAVED ... ${SAVEFILE} to ${SAVEPART}")" >/dev/console
	 [ $RETVAL -ne 1 ] && echo "$(gettext "Session NOT Saved ...")" >/dev/console
	sleep 1
 return $RETVAL
}
########################################################################






if [ 0 = 1 ] ; then 

            # working gae C3M *
                if [ "$EXIT" = "ARB_00" ] ; then # "00" will ONLY "ReStart"
                    #=============== now
                    Sbr_ReStart # C3M "00"
                    #=============== now
                fi # end: if [ "$EXIT" = "ARB_00" ]
                
            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "\
            .
            .   {0} C3M START: E3R + pMNT + CTA + uMNT 
            .                                                            "&
            #-----------------------------------------------------------------------
                sleep 1
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                kill ${GtkPid_Sbr_Box_Splash} # after return
                #
                #(: control the "E3R" "DONE" status of the Back2Root Applied activity for gui display.
                touch "${MGN_E3Rstatus}"
                sleep 1
                kill ${GtkPid_Sbr_Box_Splash} # after return
            ########################

            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
            .   {1} C3M calling  'E3R_Int_Main'
                     INTERNAL w Long-List       "&
            #-----------------------------------------------------------------------
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                sleep 3
                kill ${GtkPid_Sbr_Box_Splash} # after return
                #

                echo ">>> running --- E3R_Int_Main ==========================="
                      E3R_Int_Main         # INTERNAL w Long-List 
                echo "<<< running --- E3R_Int_Main ==========================="

            ########################
            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
            .   {2} C3M running P-mount INTERNAL "&
            #-----------------------------------------------------------------------
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                sleep 1
                kill ${GtkPid_Sbr_Box_Splash} # after return
                    Sys_MGN_pMount_All "1"  #: pMount ALL 
                #~ kill ${GtkPid_Sbr_Box_Splash} # after return
            ########################
            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
            .   {3} C3M running CTA EXTERNAL "&
            #-----------------------------------------------------------------------
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                sleep 1
                kill ${GtkPid_Sbr_Box_Splash} # after return
                #
                lcFnRunId="CTA"   # FnRun EXTERNAL
                lcFnRun="${gcSys_MyDev}/Edit_CTB/rc.z_${lcFnRunId}.sh"
                echo ">>> running --- ${lcFnRunId} --- ${lcFnRun} ==========================="
                    [ -f "${lcFnRun}" ]  &&  ${lcFnRun}  
                echo "<<< running --- ${lcFnRunId} --- ${lcFnRun} ==========================="
                kill ${GtkPid_Sbr_Box_Splash} # after return
                #
            ########################
            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
            .   {4} C3M running U-mount INTERNAL "&
            #-----------------------------------------------------------------------
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                sleep 1
                kill ${GtkPid_Sbr_Box_Splash} # after return
                    Sys_MGN_uMount_All "1"  #: uMount ALL 
                kill ${GtkPid_Sbr_Box_Splash} # after return
                #
            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "\
            .
            .   {5} C3M DONE: E3R + pMNT + CTA + uMNT 
            .                                                            "&
            #-----------------------------------------------------------------------
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                sleep 1
                kill ${GtkPid_Sbr_Box_Splash} # after return
                    #
                kill ${GtkPid_Sbr_Box_Splash} # after return

            #~ read
            #~ exit 0

            #-----------------------------------------------------------------------
            /usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "\
            .
            .  C3M ... 
            .  Fall Thru to Terminating Routines: 
            .  ReStart / ReBoot / RePowerOff
            .                                                                      "&
            #-----------------------------------------------------------------------
                RETVAL=$?
                GtkPid_Sbr_Box_Splash=$!	# capture PID
                sleep 3
                kill ${GtkPid_Sbr_Box_Splash} # after return
                    #
                kill ${GtkPid_Sbr_Box_Splash} # after return

                EXIT="${gcE3Rcontrol}"
                
                #~ if [ "$EXIT" = "ARB_00" ] ; then # "00" will ONLY "ReStart"
                    #~ #=============== 
                    #~ Sbr_ReStart # C3M "00"
                    #~ #=============== 
                #~ else # "JJ", "BB", "FF", "S7"  will ALWAYS "ReStart"
                    #=============== 
                    Sbr_ReBoot # C3M "JJ", "BB", "FF", "S7" , "X7" , "JF" 
                    #=============== 
                #~ fi
                #
                    #~ #=============== 
                    #~ Sbr_ReBoot # C3M "JJ", "BB", "FF", "S7" 
                    #~ #=============== 
             
            #~ fi # end: ARB_00, JJ, BB, FF, S7 , JF 
            #~ # end: ft( [ "$EXIT" = "ARB_00" ] || [ "$EXIT" = "ARB_JJ" ] || [ "$EXIT" = "ARB_BB" ]  || [ "$EXIT" = "ARB_FF" ] || [ "$EXIT" = "ARB_S7" ] || [ "$EXIT" = "ARB_JF" ] 


                #------------------------------------------------------------------------------------------
                        # NOTE:
                        # below: "Small Menu .lst" , does not allow 'escape' for 'change of mind'. 
                        # Direct Write of menu.lst
                        # not used  
                        # (
                        # echo "!/bin/bash"
                        # echo "timeout 5"
                        # echo "title () { ${lcOsSubId} }---{ ${lcOsSubDir} }--- ram --------SDA1"
                        # echo "find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
                        # echo "kernel /${lcOsSubDir}/vmlinuz  psubdir=${lcOsSubDir} pmedia=usbflash pfix=fsck,copy"
                        # echo "initrd /${lcOsSubDir}/initrd.gz"
                        #       ) > /mnt/home/menu.lst
                #------------------------------------------------------------------------------------------


#:======================================================================
# function EXIT:C3M_ARB_LongMenu() { ; n=0 ; } # # based on "C3M" 
# function EXIT:C3M_ARB_ORG() { ; n=0 ; } # # based on "C3M" 
# function EXIT:ARB_ORG() { ; n=0 ; } # # based on "C3M" 

#~ if [ "$EXIT" = "ARB_00" ] ; then   	####  "ARB_00"  ###  "$EXIT" = "ARB_00"  ###   "EXIT:ARB_00" ### # based on "C3M" 
    #~ n=0
#~ fi # end: if [ "$EXIT" = "ARB_00" ]
fi # end: if [ 0 = 1 ]



# rc.shutdown asktosave
	# dialog left margin dependent. 
   dialog  --title "*  ${gcSysDistroName}  *" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
  $(gettext 'hit ENTER to save session... 
  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console 
   RETVAL=$?
# dialog left margin dependent. 
   dialog  --title "*  ${gcSysDistroName}  *" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
  $(gettext '${gcSysDistroName} 
  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console 
   RETVAL=$?
# dialog left margin dependent. 
   dialog  --title "${gcAskToStr}" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\

   wait 6 seconds to NO SAVE')" 5 37 >/dev/console 
   RETVAL=$?

# dialog !!! #############################
# dialog !!! #############################
# dialog !!! #############################
  dialog  --title "   ${gcSysDevId}   " --column-separator "red" --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "\
  .   ${gcSysDistroName} 
  $(gettext 'hit ENTER to save session... 
  or wait 6 seconds to NO SAVE')" 6 37 >/dev/console 
   RETVAL=$?
# dialog !!! #############################
###


### do while in "C" syntax
#~ if [ ! -s ${gcLoopCnt} ] ; then 
    #~ ii=${gcLoopCnt}
#~ else
    #~ ii=1
#~ fi
#(: lcMsgTos is lcMsgTos="tar-out-size :${lcPupRamObjStr}: MB" 
    #~ lcMsgStrT=" Tar < DONE > " # && Sys_Str2DevTrm "$lcMsgStrT" "1" "3"
    #~ lcDialogColor="  -fg yellow -bg blue  "
#~ for (( i = 1; i <= 3; i++ )) ## "C" syntax
#~ do 
    #~ n=0
    #~ /usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text "\ 
    #~ .
    #~ .  ${lcMsgStrT}:<${i}>:${lcMsgTos}:
    #~ ." &
    #~ GTKPIDdone=${!}
    #~ sleep .5
    #~ kill "${GTKPIDdone}"
#~ done 



<button tooltip-text="'{_E3R+PowerOff_}'  < {_E3R+PowerOff_} call to E3R.sh and ReStart >" >
           <input file stock="gtk-apply"></input>
           <label> '{_E3R+PowerOff_} OK button' </label>
           <action>'EXIT:guiE3RCTARQ'</action>
</button>

    <button label="'{_E3R+PowerOff_} OK button'" 
  	 has-focus="false" height-request="32" 
tooltip-text="'EXIT:guiE3RCTARQ'
Internal Edit2Root, 
+ pMNT (pMountAllDrv),
+ CTA (Auto-Scan), 
+ uMNT (uMountAllDrv),
+ 'PowerOff' system !">
				<action>'EXIT:guiE3RCTARQ'</action>
			</button>



<button 
    tooltip-text="'EXIT:guiE3RCTARQ'  < E3R EXTERNAL call to E3R.sh and ReStart >"  tooltip-text="'EXIT:guiE3RCTARQ'>           
   <label> "'{_e+PowerOff_}'" </label>
   <input file stock="gtk-apply"></input>
<action>'EXIT:*guiE3R*'</action>
</button>
use-stock="true"



#-------------------------------------------------------------------------
# " evaluates to the value of $var, unless $var isn't set in which case it evaluates to the text "default"
# ${var:-default} evaluates to the value of $var, 
# unless $var isn't set in which case it evaluates to the text "default".
#-------------------------------------------------------------------------
#

####################################################################################
# cull Leading White Spaces 
    #~ grep -v '^$' "$lcFnSrcCode1" > "${lcFnTrgCode2}"
    #~ chmod +x ${lcFnTrgCode2}

#######  LTRIM ##################################################
####################################################################################
function sbr_ltrim() { 
    n=0
    lcltrim="sbr_ltrim: $(echo -e "${FOO}" | sed -e 's/^[[:space:]]*//')"
    echo -n "${1}"  
    echo "$lcltrim"
    #
} # end: sbr_Ltrim
####################################################################################
lcltrimvar="$(echo -e "${FOO}" | sed -e 's/^[[:space:]]*//')"
echo "$lcltrimvar"
    ###
echo "================================"
echo ">>> sbr_ltrim param formula"
sbr_ltrim "$(echo -e "${testorig}" | sed -e 's/^[[:space:]]*//')"
echo "<<< sbr_ltrim has set testorig into: lcltrim=${lcltrim}"
    #
echo "-------------------------------------------------"
#######  LTRIM ##################################################


#(:
#(:  /usr/lib/gtkdialog/box_ok "Error" error "File Not Found..."
#(:
########################################################################
        #~ lcFnRunOne="rc.z_S2F.sh"
        #~ lcFnRun="${gcSys_MyDev}/Edit_S2F/${lcFnRunOne}" 
		#~ if [ -f "$lcFnRun" ] ; then  # *guiE3R* External Call !
            #~ n=0
			#~ # ${lcFnRun}   # EXTERNAL Call !
            #~ . /usr/lib/gtkdialog/box_ok "TEST" error "A...${lcFnRun}..."
        #~ elif
            #~ lcFnRun="/root/my-applications/${lcFnRunOne}" 
            #~ n=0
			#~ # ${lcFnRun}   # EXTERNAL Call !
            #~ . /usr/lib/gtkdialog/box_ok "TEST" error "B...${lcFnRun}..."
        #~ else
            #~ n=0
            #~ . /usr/lib/gtkdialog/box_ok "TEST" error "C...${lcFnRun}..."
		#~ fi
########################################################################

        #~ lcFnRunOne="rc.z_S2F.sh"
        #~ lcFnRun="${gcSys_MyDev}/Edit_S2F/${lcFnRunOne}" 
		#~ if [ -f "$lcFnRun" ] ; then  # *guiE3R* External Call !
            #~ n=0
            #~ # ${lcFnRun}   # EXTERNAL Call !
            #~ . /usr/lib/gtkdialog/box_ok "TEST" error "0...${lcFnRun}..."
        #~ fi
		#~ if [ -f "$lcFnRun" ] 
            #~ then  # *guiE3R* External Call ! 
                #~ n=0
                #~ # ${lcFnRun}   # EXTERNAL Call !
                #~ . /usr/lib/gtkdialog/box_ok "TEST" error "1...${lcFnRun}..."
        #~ elif
            #~ then 
                #~ lcFnRun="/root/my-applications/rc.z_E3R.sh" 
                #~ n=0
                #~ # ${lcFnRun}   # EXTERNAL Call !
                #~ . /usr/lib/gtkdialog/box_ok "TEST" error "2...${lcFnRun}..."
        #~ else
            #~ n=0
            #~ . /usr/lib/gtkdialog/box_ok "TEST" error "3...${lcFnRun}..."
		#~ fi
########################################################################


       lcFnRunId="CTA"   # FnRun from "CTA" external
        lcFileRun1="${gcSys_MyDev}/Edit_${lcFnRunId}/rc.z_${lcFnRunId}.sh"
        lcFileRun2="/root/my-applications/bin//rc.z_${lcFnRunId}.sh"
        lcFileRun2="${lcFnRunId}" ### local 
        echo ">>> running --- ${lcFnRunId} --- ${lcFnRun} === external====="
		if [ -f "${lcFnRun1}" ] ; then  ### run external /Edit_XXX/ 
                n=0 
                # ${lcFnRun1}   # EXTERNAL Call !
        elif [ -f "$lcFnRun2" ] ; then  ### run /my-applications/bin  
                n=0 
                # ${lcFnRun2}   # /bin
        elif [ -f "$lcFnRun3" ] ; then  ### run local subroutine 
                n=0 
                # ${lcFnRun3}   # subroutine
        else
                . /usr/lib/gtkdialog/box_ok "TEST" error "3...${lcFnRunId}..."
        fi

########################################################################


<button>  <label> '{{_E3R+ReBoot_}}'   </label>
               <input file stock="gtk-apply"> 
               tooltip-text="'===???????EXIT:guiE3RCTARQ==='
    Internal Edit3Root, 
    + pMNT (pMountAllDrv),
    + CTA (Auto-Scan), 
    + uMNT (uMountAllDrv),
    + 'ReBoot' system !" </input>
               <action>'EXIT:guiE3RCTARB'</action>
</button>



#:##################################################
function Sys_Splash_Flip() {   #: Active Flipping
    n=0
    lcParam1="${1}"

    #~ kill ${GtkPidFlip1}    ### kill any previous splash ? err flag 
    #~ kill ${GtkPidFlip2}    ### kill any previous splash ? err flag 
# -border true 
#--- flipping colors -----------------------------------------------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg red -bg black  -close never -text " ${lcParam1} " &  
	GtkPidFlip1=$!	### kill #((splash
sleep .3
    kill ${GtkPidFlip1}    ### kill any previous splash ? err flag 
#--- flipping colors -----------------------------------------------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg black -border true  -close never -text " ${lcParam1} " &  
	GtkPidFlip2=$!	### kill # later
sleep .3
#--------------------------------------------------------------------------------------------------------------

        #---------------------------------------
        # Sys_Splash_Flip ${lcMsgStr}
        # kill ${GtkPidFlip1} 
        # kill ${GtkPidFlip2} 
        #---------------------------------------
} # end: EXR_Copy_Splash_Flip

